module global
  real(kind=8),allocatable::lamda1(:,:)
  real(kind=8),allocatable::lamda2(:,:)
  real(kind=8),allocatable::daynum(:,:)
  real(kind=8),allocatable::wrk1(:)
  real(kind=8),allocatable::wrk2(:)
  real(kind=8),allocatable::wrk3(:)
  real(kind=8),allocatable::pos_pos(:)
  real(kind=8),allocatable::pos_neg(:)
  real(kind=8),allocatable::neg_neg(:)
end module global

program calculate_statistics
!! by @raccoon
!! if a variable is called f, then fbar is the boxcar smooth field
!! and fstar is the highpass part, pay attention to control the output
  use netcdf
  use global
  implicit none
  !for licom
  !integer(kind=4),parameter:: imt=3602,jmt=1683,kmt=55,tmt=1,ref_num=32
  !for sose
  integer(kind=4),parameter:: imt=2160,jmt=320,nvar=9,all_num=imt*jmt
  integer(kind=4):: ii,jj,ivar,nn1,nn2,nn3
  integer(kind=4):: ncid1,ncid2,ncid3,ncido,ierr,lon_dim_id,lat_dim_id,lev_dim_id
  integer(kind=4):: var_id1,var_id2,var_id3,var_id
  real(kind=8):: bars(nvar,3,5),temp
  integer(kind=4):: start4(4),count4(4),start1(1),count1(1)
  ! variables for ncfiles
  character(200) :: DIR_in="../SOSE/K_tensor-2deg/eigen/"
  character(200) :: DIR_out="./"
  character(200) :: fin1,fin2,fin3,fout,filename_1(nvar),filename_2(nvar)
  character(200) :: units,vout,long_names

  real(kind=8) :: spval=1.e+35,epsln=1.e-20,less_spval=1.e20
  logical:: display=.True.
  filename_1 = (/"lambda1-sgs-size3-2deg-1yr-2008.nc","lambda1-Rynlds-size3-2deg-1yr-2008.nc",&
                "lambda1-nonRynlds-size3-2deg-1yr-2008.nc",&
                "lambda1-stationary-size3-2deg-1yr-2008.nc","stationary-lambda1-Rynlds-size3-2deg-1yr-2008.nc",&
                "stationary-lambda1-nonRynlds-size3-2deg-1yr-2008.nc",&
                "lambda1-transient-size3-2deg-1yr-2008.nc","transient-lambda1-Rynlds-size3-2deg-1yr-2008.nc",&
                "transient-lambda1-nonRynlds-size3-2deg-1yr-2008.nc"/)
  filename_2 = (/"lambda2-sgs-size3-2deg-1yr-2008.nc","lambda2-Rynlds-size3-2deg-1yr-2008.nc",&
                "lambda2-nonRynlds-size3-2deg-1yr-2008.nc",&
                "lambda2-stationary-size3-2deg-1yr-2008.nc","stationary-lambda2-Rynlds-size3-2deg-1yr-2008.nc",&
                "stationary-lambda2-nonRynlds-size3-2deg-1yr-2008.nc",&
                "lambda2-transient-size3-2deg-1yr-2008.nc","transient-lambda2-Rynlds-size3-2deg-1yr-2008.nc",&
                "transient-lambda2-nonRynlds-size3-2deg-1yr-2008.nc"/)
  ! info for nc
  units      = ""
  vout       = "bars"
  long_names = "5percentile,mean-std,mean,mean+std,95percentile" 
  !============================================================================
  start4(1)=1 ; count4(1)=imt
  start4(2)=1 ; count4(2)=jmt
  start4(3)=3 ; count4(3)=1  !!topobaric for 3680
  start4(4)=1 ; count4(4)=1

  do ivar=1,nvar
  !!!=============== read data ===============
    fin1=trim(DIR_in)//trim(filename_1(ivar))
    ierr=nf90_open(trim(fin1),nf90_nowrite,ncid1)
    call handle_netcdf_error(trim(fin1), __LINE__, ierr)
    ierr = nf90_inq_varid(ncid1, "lambda1", var_id1)
    call handle_netcdf_error(trim(fin1), __LINE__, ierr)
    allocate(lamda1(imt,jmt))
    ierr = nf90_get_var(ncid1, var_id1, lamda1,  start4, count4)
    call handle_netcdf_error(trim(fin1), __LINE__, ierr)

    ierr = nf90_close(ncid1)
    call handle_netcdf_error(trim(fin1), __LINE__, ierr)
  !!!========================================================

    fin2=trim(DIR_in)//trim(filename_2(ivar))
    ierr=nf90_open(trim(fin2),nf90_nowrite,ncid2)
    call handle_netcdf_error(trim(fin2), __LINE__, ierr)
    ierr = nf90_inq_varid(ncid2, "lambda2", var_id2)
    call handle_netcdf_error(trim(fin2), __LINE__, ierr)
    allocate(lamda2(imt,jmt))
    ierr = nf90_get_var(ncid2, var_id2, lamda2,  start4, count4)
    call handle_netcdf_error(trim(fin2), __LINE__, ierr)

    ierr = nf90_close(ncid2)
    call handle_netcdf_error(trim(fin2), __LINE__, ierr)
  !!!========================================================

    fin3="../SOSE/zz_topo/outcrop-counter-sose-2008.nc"
    ierr=nf90_open(trim(fin3),nf90_nowrite,ncid3)
    call handle_netcdf_error(trim(fin3), __LINE__, ierr)
    ierr = nf90_inq_varid(ncid3, "daynum", var_id3)
    call handle_netcdf_error(trim(fin3), __LINE__, ierr)
    allocate(daynum(imt,jmt))
    ierr = nf90_get_var(ncid3, var_id3, daynum,  start4, count4)
    call handle_netcdf_error(trim(fin3), __LINE__, ierr)

    ierr = nf90_close(ncid3)
    call handle_netcdf_error(trim(fin3), __LINE__, ierr)

    where(abs(daynum).ge.1.0)
        lamda1=spval
    end where

    where(abs(daynum).ge.1.0)
        lamda2=spval
    end where

    write(*,*)'read data ok'

    !! 3 eigenvalue configuration
    nn1=0
    nn2=0
    nn3=0
!     pos_pos=0.0
!     pos_neg=0.0
!     neg_neg=0.0
    allocate(pos_pos(all_num))
    allocate(pos_neg(all_num))
    allocate(neg_neg(all_num))

    do ii=1,imt
      do jj=1,jmt
        if((abs(lamda1(ii,jj)).lt.less_spval).and.(lamda1(ii,jj).ge.0.0) .and. (lamda2(ii,jj).ge.0.0))then
          nn1=nn1+1
          pos_pos(nn1)=log10(abs(lamda1(ii,jj))/(abs(lamda2(ii,jj))+epsln))
        end if

        if((abs(lamda1(ii,jj)).lt.less_spval).and.(lamda1(ii,jj).ge.0.0) .and. (lamda2(ii,jj).lt.0.0))then
          nn2=nn2+1
          pos_neg(nn2)=log10(abs(lamda1(ii,jj))/(abs(lamda2(ii,jj))+epsln))
        end if

        if((abs(lamda1(ii,jj)).lt.less_spval).and.(lamda1(ii,jj).lt.0.0) .and. (lamda2(ii,jj).lt.0.0))then
          nn3=nn3+1
          neg_neg(nn3)=log10(abs(lamda1(ii,jj))/(abs(lamda2(ii,jj))+epsln))
        end if
      end do
    end do

    allocate(wrk1(nn1))
    allocate(wrk2(nn2))
    allocate(wrk3(nn3))

    wrk1 = pos_pos(1:nn1)
    wrk2 = pos_neg(1:nn2)
    wrk3 = neg_neg(1:nn3)
    write(*,*)"ivar=",ivar
    write(*,*)"nn1=",nn1,"nn2=",nn2,"nn3=",nn3
    write(*,*)"-------- line 126 --------"
    !!排序，均值，标准差，10和90分位点
    do ii=nn1-1,1,-1
      do jj=1,ii
        if(wrk1(jj).gt.wrk1(jj+1))then
          temp=wrk1(jj)
          wrk1(jj)=wrk1(jj+1)
          wrk1(jj+1)=temp
        end if
      end do
    end do

    do ii=nn2-1,1,-1
      do jj=1,ii
        if(wrk2(jj).gt.wrk2(jj+1))then
          temp=wrk2(jj)
          wrk2(jj)=wrk2(jj+1)
          wrk2(jj+1)=temp
        end if
      end do
    end do

    do ii=nn3-1,1,-1
      do jj=1,ii
        if(wrk3(jj).gt.wrk3(jj+1))then
          temp=wrk3(jj)
          wrk3(jj)=wrk3(jj+1)
          wrk3(jj+1)=temp
        end if
      end do
    end do
    write(*,*)"-------- line 153 --------"
    !! bars(:,:,1)=>5 percentile
    bars(ivar,1,1)=wrk1(int(nn1*0.05))
    bars(ivar,2,1)=wrk2(int(nn2*0.05))
    bars(ivar,3,1)=wrk3(int(nn3*0.05))

    !! bars(:,:,5)=>95 percentile
    bars(ivar,1,5)=wrk1(int(nn1*0.95))
    bars(ivar,2,5)=wrk2(int(nn2*0.95))
    bars(ivar,3,5)=wrk3(int(nn3*0.95))

    !! bars(:,:,3)=>mean
    bars(ivar,1,3)=sum(wrk1)/nn1
    bars(ivar,2,3)=sum(wrk2)/nn2
    bars(ivar,3,3)=sum(wrk3)/nn3

    !! bars(:,:,2)=>mean-std
    bars(ivar,1,2)=bars(ivar,1,3)-sqrt(sum((wrk1-bars(ivar,1,3))**2.0)/nn1)
    bars(ivar,2,2)=bars(ivar,2,3)-sqrt(sum((wrk2-bars(ivar,2,3))**2.0)/nn2)
    bars(ivar,3,2)=bars(ivar,3,3)-sqrt(sum((wrk3-bars(ivar,3,3))**2.0)/nn3)

    !! bars(:,:,4)=>mean+std
    bars(ivar,1,4)=bars(ivar,1,3)+sqrt(sum((wrk1-bars(ivar,1,3))**2.0)/nn1)
    bars(ivar,2,4)=bars(ivar,2,3)+sqrt(sum((wrk2-bars(ivar,2,3))**2.0)/nn2)
    bars(ivar,3,4)=bars(ivar,3,3)+sqrt(sum((wrk3-bars(ivar,3,3))**2.0)/nn3)

    !write(*,*)"wrk3=",wrk3
    write(*,*)"pos&pos:bars(ivar,1,:)=",bars(ivar,1,:)
    write(*,*)"pos&neg:bars(ivar,2,:)=",bars(ivar,2,:)
    write(*,*)"neg&neg:bars(ivar,3,:)=",bars(ivar,3,:)

    deallocate(lamda1)
    deallocate(lamda2)
    deallocate(daynum)
    deallocate(pos_pos)
    deallocate(pos_neg)
    deallocate(neg_neg)
    deallocate(wrk1)
    deallocate(wrk2)
    deallocate(wrk3)

  end do
  write(*,*)"bars=",bars


  fout=trim(DIR_out)//"lambda-statistics-bars.nc"
  !!!---------nf90_create ! create netcdf dataset: enter define mode
  ierr = nf90_create(trim(fout), nf90_clobber, ncido)
  call handle_netcdf_error(trim(fout), __line__, ierr)
  !!!---------nf90_global ! put the global attributes
  ierr = nf90_put_att(ncido, nf90_global, "title", "lambda-statistics-bars")
  call handle_netcdf_error(trim(fout), __line__, ierr)
  !!!------------nf90_def_dim ! define dimensions: from name and length
  ierr = nf90_def_dim(ncido, "nvar", nvar, lon_dim_id)
  call handle_netcdf_error(trim(fout), __line__, ierr)
  ierr = nf90_def_dim(ncido, "types", 3, lat_dim_id)
  call handle_netcdf_error(trim(fout), __line__, ierr)
  ierr = nf90_def_dim(ncido, "nbar", 5, lev_dim_id)
  call handle_netcdf_error(trim(fout), __line__, ierr)
  !!!------------nf90_def_var ! define valueiables: from name, type, dims
  ierr = nf90_def_var(ncido, trim(vout), nf90_double, [lon_dim_id,lat_dim_id,lev_dim_id],var_id)
  call handle_netcdf_error(trim(fout), __line__, ierr)
  ierr = nf90_put_att(ncido, var_id, "long_name", trim(long_names))
  call handle_netcdf_error(trim(fout), __line__, ierr)
  !!!------------ nf90_enddef  ----------------------------------
  ierr = nf90_enddef(ncido)
  call handle_netcdf_error(trim(fout), __line__, ierr)
  !--------------nf90_put_var ! assign attribute values
  ierr = nf90_put_var(ncido, var_id, bars)
  call handle_netcdf_error(trim(fout), __line__, ierr)
  !!!--------------------- close ----------------------------------
  ierr = nf90_close(ncido)
  call handle_netcdf_error(trim(fout), __line__, ierr)


end program calculate_statistics




!===============================================================================
! nc running messages to facilitate checking programs
!===============================================================================
subroutine handle_netcdf_error(fname,line,err)
use netcdf
  implicit none
  character(*)::fname
  integer(kind=4)::line,err
  character(80)::err_msg
  err_msg=nf90_strerror(err)
  write(*,"(i5,a80,a70)")line,fname,err_msg
  if(trim(err_msg).eq."Not a netCDF id")then
    write(*,*)trim(fname)," Not exist, Plz Check!!!"
    stop
  end if
end subroutine handle_netcdf_error
