load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begin
;放大区域南印度洋展示 (a) 通量/位涡，(b) 通量重构，(c) 条件数，(d)，(e)(f) 两个特征值，六个子图（构图3*2）

dir = "../SOSE/"
fig_dir = "./"
fig_name = "figureC1"

panel_name = (/"(a) 9 samples, 3*3","(b) 25 samples, 5*5","(c) 49 samples, 7*7",\
              "(d) 81 samples, 9*9","(e) 169 samples, 13*13, 2deg","(f) 361 samples, 19*19, 3deg"/)
;;--------------------------------------------;;
res = True
res@gsnDraw=False
res@gsnFrame=False
res@gsnAddCyclic=False
res@gsnCenterString=""
res@gsnLeftStringFontHeightF = 0.02
res@gsnRightString=""
res@cnFillOn=True
res@cnLinesOn=False
res@cnFillMode = "RasterFill"
res@cnRasterSmoothingOn = True
res@lbLabelBarOn = True
res@mpMaxLonF=110
res@mpMinLonF=50
res@mpMaxLatF=-35
res@mpMinLatF=-65
res@mpMonoFillColor = True
res@mpFillColor = "gray79"

resv=True
resv@gsnDraw=False
resv@gsnFrame=False
resv@gsnAddCyclic=False
resv@gsnLeftString=""
resv@gsnRightString=""
resv@vcPositionMode            = "ArrowCenter"  
resv@vcGlyphStyle              = "Fillarrow"  
resv@vcFillArrowEdgeThicknessF = 2        
resv@vcFillArrowEdgeColor      = "white"   
resv@vcFillArrowFillColor      = "black"  
resv@vcFillArrowWidthF         = 0.2     
resv@vcFillArrowHeadXF         = 0.01       
resv@vcFillArrowHeadYF         = 0.001      
resv@vcFillArrowHeadInteriorXF = 0.001         
resv@vcMinDistanceF            = 0.01    
; resv@vcMinMagnitudeF           = 1.0    
resv@vcFillArrowMinFracWidthF =1.0 
resv@vcFillArrowHeadMinFracXF =1.0  
resv@vcFillArrowHeadMinFracYF =1.0 
resv@vcRefAnnoOn               = False 
resv@vcRefMagnitudeF           = 1.0  
resv@vcRefLengthF              = 0.005   

pres = True
pres@txString = ""
pres@gsnPanelLabelBar = False
;pres@gsnPanelFigureStrings = (/"a","b","c","d","e"/)
pres@gsnPanelFigureStringsFontHeightF=0.01
pres@amJust = "Topleft"
; pres@lbLabelFontHeightF = 0.015
; pres@lbLabelStride = 1

setfileoption("nc","Format","LargeFile")
setvalues NhlGetWorkspaceObjectId()
  "wsMaximumSize": 600000000
end setvalues

wks_type="pdf"
wks_type@wkWidth=100000
wks_type@wkHeight=100000
wks=gsn_open_wks(wks_type,fig_dir+fig_name)
;;--------------------------------------------------------------;;
base = new(4,graphic)
plot = new(4,graphic)

;; ----- panel 1 ----- ;;
f1=addfile(dir+"qq/qq-Smean-2deg-1yr-2008.nc","r")
qq=f1->qbar(0,2,:,0:2159)
qq=log10(-qq)

f2=addfile(dir+"flux/F-vq-sgs-2deg-1yr-2008.nc","r")
flux=f2->flux(0,2,:,0:2159)
flux=flux*1e+13


values = new(201,double)
aa = fspan(0,4,101)
values(101:200)=10^aa(1:100)
bb = fspan(4,0,101)
values(0:99)=10^bb(0:99)
values(100)=0.0
values(0:99)=-values(0:99)
fill = new(202,integer)
fill_wrk = fspan(25,125,101)
fill(0:100) = floattoint(fill_wrk)
fill_wrk = fspan(130,230,101)
fill(101:201) = floattoint(fill_wrk)

res1 = res
res1@cnFillPalette="ncl_default"
res1@gsnLeftString="(a) shading: flux_y, contour: log10(-PV)"
res1@cnLevelSelectionMode="ExplicitLevels"
res1@cnLevels       = values
res1@cnFillColors       = fill
res1@lbLabelStride = 25
res1@lbBoxLinesOn=False
; res1@cnLevels       = (/-30000,-10000,-3000,-1000,-300,-100,-30,-10,-3,0,3,10,30,100,300,1000,3000,10000,30000/)
; res1@cnFillColors       = (/4,7,10,20,35,50,65,80,100,120,    136,155,175,195,210,225,240,245,248,251/)

base(0)=gsn_csm_contour_map(wks,flux(:,0:2159),res1)

res1@cnLevelSelectionMode="ManualLevels"
res1@cnMaxLevelValF=-5
res1@cnMinLevelValF=-9
res1@cnLevelSpacingF=0.02
res1@cnFillOn = False
res1@cnLinesOn = True
res1@cnLineLabelsOn = False
res1@cnLineThicknessF = 8
res1@gsnLeftString=""

plot(0)=gsn_csm_contour(wks,qq(:,0:2159),res1)
overlay(base(0),plot(0))

delete([/qq,flux,values,aa,bb,fill,fill_wrk/])

;; ----- panel 2 ----- ;;
values = new(201,double)
aa = fspan(0,4,101)
values(101:200)=10^aa(1:100)
bb = fspan(4,0,101)
values(0:99)=10^bb(0:99)
values(100)=0.0
values(0:99)=-values(0:99)
fill = new(202,integer)
fill_wrk = fspan(25,125,101)
fill(0:100) = floattoint(fill_wrk)
fill_wrk = fspan(130,230,101)
fill(101:201) = floattoint(fill_wrk)

res2 = res
res2@cnFillPalette="ncl_default"
res2@gsnLeftString="(b) flux recostruct"
res2@cnLevelSelectionMode="ExplicitLevels"
res2@cnLevels       = values
res2@cnFillColors       = fill
res2@lbLabelStride = 25
res2@lbBoxLinesOn=False
; res2@cnLevels       = (/-30000,-10000,-3000,-1000,-300,-100,-30,-10,-3,0,3,10,30,100,300,1000,3000,10000,30000/)
; res2@cnFillColors       = (/4,7,10,20,35,50,65,80,100,120,    136,155,175,195,210,225,240,245,248,251/)

f=addfile(dir+"flux/flux_check/Fre-vq-sgs-size3-2deg-1yr-2008.nc","r")
flux_re=f->flux(0,2,:,0:2159)
flux_re=flux_re*1e13

base(1)=gsn_csm_contour_map(wks,flux_re,res2)

delete([/flux_re,values,aa,bb,fill,fill_wrk/])

;; ----- panel 3 ----- ;;
res3 = res
res3@cnFillPalette="rainbow"
res3@gsnLeftString="(c) condition number"
res3@cnLevelSelectionMode="ExplicitLevels"
res3@cnLevels       = (/0, 10, 20, 30, 40, 50, 100/)
res3@cnFillColors   = (/5,30,55,75,125,145,165,185/)

f=addfile(dir+"K_tensor-2deg/cond-sgs-size3-2deg-1yr-2008.nc","r")
cond=f->cond(0,2,:,0:2159)

base(2)=gsn_csm_contour_map(wks,cond,res3)

delete(cond)

;; ----- panel 4 ----- ;;
;重构相对误差多样本数的pdf统计分布廓线
ff=addfile(dir+"zz_topo/outcrop-counter-sose-2008.nc", "r")
daynum=ff->daynum(0,2,:,0:2159)
daynum = (daynum/73.0)*100.0

f=addfile(dir+"flux/F-vq-sgs-2deg-1yr-2008.nc","r")
flux=f->flux(0,2,:,0:2159)
flux=flux*1e+12
flux = where(abs(daynum).lt.1.0, flux, flux@_FillValue)

fname = (/"Fre-vq-sgs-size1-2deg-1yr-2008.nc","Fre-vq-sgs-size2-2deg-1yr-2008.nc",\
        "Fre-vq-sgs-size3-2deg-1yr-2008.nc","Fre-vq-sgs-size4-2deg-1yr-2008.nc",\
        "Fre-vq-sgs-size6-2deg-1yr-2008.nc","Fre-vq-sgs-size9-2deg-1yr-2008.nc"/)

bin_start=0.0
num_bin=50
bin_int=1.0/num_bin
pi=3.14159

wrk_bin=new((/320,2160/),double)
wrk_all=new((/320,2160/),double)
frac=new((/6,num_bin/),double) ;;9 vars
x = fspan(0.0,1.0,num_bin)

do ivar=0,5
  print("==== ivar"+ivar)
    f=addfile(dir+"flux/flux_check/"+fname(ivar),"r")
    lat=f->lat
    flux_re=f->flux(0,2,:,0:2159)  ;;3680
    flux_re=flux_re*1e12
    flux_re = where(abs(daynum).lt.10.0, flux_re, flux_re@_FillValue)
    diff = abs((flux_re - flux)/flux)
    copy_VarMeta(flux, diff)

    wrk_all = where(abs(diff).lt.1e+10, 1, 0)

    do jj=0,319
          wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    do nbin=0,num_bin-1
        wrk_bin = where((diff.gt.(bin_start+nbin*bin_int) .and. diff.lt.(bin_start+(nbin+1)*bin_int)),1,0)

        do jj=0,319
            wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
        end do

        frac(ivar,nbin)=sum(wrk_bin)/sum(wrk_all)
    end do
end do ;;ivar loop

lres = True
lres@gsnDraw               = False
lres@gsnFrame              = False

lres@vpWidthF              = 0.75
lres@vpHeightF             = 0.45

lres@trXMinF               = 0.01
lres@trXMaxF               = 1.0
lres@trYMinF               = 0.0
lres@trYMaxF               = 12.0

lres@tmXBLabelFontHeightF  = 0.018
lres@tmYLLabelFontHeightF  = 0.018
lres@pmLegendWidthF=0.12
lres@pmLegendHeightF=0.2
lres@pmLegendOrthogonalPosF=-1.05
lres@pmLegendParallelPosF=0.8

lres@gsnLeftStringFontHeightF = 0.02
lres@gsnLeftString="(d) PDF of relative reconstruct error"

lres@xyLineThicknesses=(/20,20,40,15,15,15/)
lres@xyLineColors=(/"blue","green","red","purple","black","orange"/)
lres@xyDashPatterns=(/1,1,0,1,2,2/)

lres@pmLegendDisplayMode="Always"
lres@xyExplicitLegendLabels=(/"9 samples","25 samples","49 samples","81 samples","169 samples","361 samples"/)
lres@lgLabelFontHeightF=0.016

;frac = sqrt(frac*100)
frac = frac*100
print(frac(0,:))
print(frac(1,:))
print(frac(2,:))
print(frac(3,:))
print(frac(4,:))
print(frac(5,:))
base(3) = gsn_csm_xy(wks,x,frac,lres)

;;---------------------------------;;
gsn_panel(wks,base,(/2,2/),pres)



end
