load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begin

dir = (/"../SOSE/K_tensor-2deg/eigen/",\
       "../SOSE/topography/",\
       "../SOSE/PV_grad/",\
       "../SOSE/"/)
pic_dir = "./"
vname_1 = (/"lambda1","lambda1","lambda1","lambda1","lambda1",\
           "lambda2","lambda2","lambda2","lambda2","lambda2"/)
vname_2 = (/"alpha","alpha","alpha","alpha","alpha",\
           "beta","beta","beta","beta","beta"/)

file_1 = (/"lambda1-sgs-size3-2deg-1yr-2008.nc",\
           "lambda1-stationary-size3-2deg-1yr-2008.nc",\ 
           "lambda1-transient-size3-2deg-1yr-2008.nc",\
           "lambda1-Rynlds-size3-2deg-1yr-2008.nc",\
           "lambda1-nonRynlds-size3-2deg-1yr-2008.nc",\
           "lambda2-sgs-size3-2deg-1yr-2008.nc",\
           "lambda2-stationary-size3-2deg-1yr-2008.nc",\ 
           "lambda2-transient-size3-2deg-1yr-2008.nc",\
           "lambda2-Rynlds-size3-2deg-1yr-2008.nc",\
           "lambda2-nonRynlds-size3-2deg-1yr-2008.nc"/)
file_2 = (/"alpha-PV-sgs-size3-2deg-1yr-2008.nc",\
           "alpha-PV-stationary-size3-2deg-1yr-2008.nc",\
           "alpha-PV-transient-size3-2deg-1yr-2008.nc",\
           "alpha-PV-Rynlds-size3-2deg-1yr-2008.nc",\
           "alpha-PV-nonRynlds-size3-2deg-1yr-2008.nc",\
           "beta-PV-sgs-size3-2deg-1yr-2008.nc",\
           "beta-PV-stationary-size3-2deg-1yr-2008.nc",\
           "beta-PV-transient-size3-2deg-1yr-2008.nc",\
           "beta-PV-Rynlds-size3-2deg-1yr-2008.nc",\
           "beta-PV-nonRynlds-size3-2deg-1yr-2008.nc"/)

file_6 = (/"pqpx-2deg-1yr-2008.nc",\
           "pqpy-2deg-1yr-2008.nc"/)
pic_name = "figureC10"
pi=3.14159265
eps=1e-20
num_bin=45
bin_int=90.0/num_bin
bin_start=0.0
wrk_bin=new((/320,2160/),double)
wrk_all=new((/320,2160/),double)
frac=new((/40,num_bin/),double) ;;18 bins
x = fspan(0,90,num_bin)
plot = new(5,graphic)

ff=addfile(dir+"zz_topo/outcrop-counter-sose-2008.nc", "r")
daynum=ff->daynum(0,2,:,0:2159)
daynum = (daynum/73.0)*100.0

ff3=addfile(dir(2)+file_6(0),"r")  ;;pqpx
pqpx=ff3->pqpx(0,2,:,0:2159)
pqpx = where(abs(daynum).lt.1.0, pqpx, pqpx@_FillValue)
ff4=addfile(dir(2)+file_6(1),"r")  ;;pqpy
pqpy=ff4->pqpy(0,2,:,0:2159)
pqpy = where(abs(daynum).lt.1.0, pqpy, pqpy@_FillValue)

f1=addfile(dir(0)+file_1(0),"r")  ;;lambda1-ttl
f2=addfile(dir(0)+file_1(1),"r")  ;;lambda1-stt
f3=addfile(dir(0)+file_1(2),"r")  ;;lambda1-trs
f4=addfile(dir(0)+file_1(3),"r")  ;;lambda1-Rynlds
f5=addfile(dir(0)+file_1(4),"r")  ;;lambda1-nonRynlds

f6=addfile(dir(0)+file_1(5),"r")  ;;lambda2-ttl
f7=addfile(dir(0)+file_1(6),"r")  ;;lambda2-stt
f8=addfile(dir(0)+file_1(7),"r")  ;;lambda2-trs
f9=addfile(dir(0)+file_1(8),"r")  ;;lambda2-Rynlds
f10=addfile(dir(0)+file_1(9),"r")  ;;lambda2-nonRynlds

lat=f1->lat
lambda1_ttl=f1->lambda1(0,2,:,0:2159)
lambda1_ttl = where(abs(daynum).lt.1.0, lambda1_ttl, lambda1_ttl@_FillValue)
lambda1_stt=f2->lambda1(0,2,:,0:2159)
lambda1_stt = where(abs(daynum).lt.1.0, lambda1_stt, lambda1_stt@_FillValue)
lambda1_trs=f3->lambda1(0,2,:,0:2159)
lambda1_trs = where(abs(daynum).lt.1.0, lambda1_trs, lambda1_trs@_FillValue)
lambda1_Rynlds=f4->lambda1(0,2,:,0:2159)
lambda1_Rynlds = where(abs(daynum).lt.1.0, lambda1_Rynlds, lambda1_Rynlds@_FillValue)
lambda1_nonRynlds=f5->lambda1(0,2,:,0:2159)
lambda1_nonRynlds = where(abs(daynum).lt.1.0, lambda1_nonRynlds, lambda1_nonRynlds@_FillValue)

lambda2_ttl=f6->lambda2(0,2,:,0:2159)
lambda2_ttl = where(abs(daynum).lt.1.0, lambda2_ttl, lambda2_ttl@_FillValue)
lambda2_stt=f7->lambda2(0,2,:,0:2159)
lambda2_stt = where(abs(daynum).lt.1.0, lambda2_stt, lambda2_stt@_FillValue)
lambda2_trs=f8->lambda2(0,2,:,0:2159)
lambda2_trs = where(abs(daynum).lt.1.0, lambda2_trs, lambda2_trs@_FillValue)
lambda2_Rynlds=f9->lambda2(0,2,:,0:2159)
lambda2_Rynlds = where(abs(daynum).lt.1.0, lambda2_Rynlds, lambda2_Rynlds@_FillValue)
lambda2_nonRynlds=f10->lambda2(0,2,:,0:2159)
lambda2_nonRynlds = where(abs(daynum).lt.1.0, lambda2_nonRynlds, lambda2_nonRynlds@_FillValue)
printVarSummary(lambda2_trs)

fin1=addfile(dir(0)+file_2(0),"r")  ;;alpha-ttl
fin2=addfile(dir(0)+file_2(1),"r")  ;;alpha-stt
fin3=addfile(dir(0)+file_2(2),"r")  ;;alpha-trs
fin4=addfile(dir(0)+file_2(3),"r")  ;;alpha-Rynlds
fin5=addfile(dir(0)+file_2(4),"r")  ;;alpha-nonRynlds

fin6=addfile(dir(0)+file_2(5),"r")  ;;beta-ttl
fin7=addfile(dir(0)+file_2(6),"r")  ;;beta-stt
fin8=addfile(dir(0)+file_2(7),"r")  ;;beta-trs
fin9=addfile(dir(0)+file_2(8),"r")  ;;beta-Rynlds
fin10=addfile(dir(0)+file_2(9),"r")  ;;beta-nonRynlds

alpha_ttl_orig=fin1->alpha(0,2,:,0:2159)
alpha_ttl_orig = where(abs(daynum).lt.1.0, alpha_ttl_orig, alpha_ttl_orig@_FillValue)
alpha_stt_orig=fin2->alpha(0,2,:,0:2159)
alpha_stt_orig = where(abs(daynum).lt.1.0, alpha_stt_orig, alpha_stt_orig@_FillValue)
alpha_trs_orig=fin3->alpha(0,2,:,0:2159)
alpha_trs_orig = where(abs(daynum).lt.1.0, alpha_trs_orig, alpha_trs_orig@_FillValue)
alpha_Rynlds_orig=fin4->alpha(0,2,:,0:2159)
alpha_Rynlds_orig = where(abs(daynum).lt.1.0, alpha_Rynlds_orig, alpha_Rynlds_orig@_FillValue)
alpha_nonRynlds_orig=fin5->alpha(0,2,:,0:2159)
alpha_nonRynlds_orig = where(abs(daynum).lt.1.0, alpha_nonRynlds_orig, alpha_nonRynlds_orig@_FillValue)

beta_ttl_orig=fin6->beta(0,2,:,0:2159)
beta_ttl_orig = where(abs(daynum).lt.1.0, beta_ttl_orig, beta_ttl_orig@_FillValue)
beta_stt_orig=fin7->beta(0,2,:,0:2159)
beta_stt_orig = where(abs(daynum).lt.1.0, beta_stt_orig, beta_stt_orig@_FillValue)
beta_trs_orig=fin8->beta(0,2,:,0:2159)
beta_trs_orig = where(abs(daynum).lt.1.0, beta_trs_orig, beta_trs_orig@_FillValue)
beta_Rynlds_orig=fin9->beta(0,2,:,0:2159)
beta_Rynlds_orig = where(abs(daynum).lt.1.0, beta_Rynlds_orig, beta_Rynlds_orig@_FillValue)
beta_nonRynlds_orig=fin10->beta(0,2,:,0:2159)
beta_nonRynlds_orig = where(abs(daynum).lt.1.0, beta_nonRynlds_orig, beta_nonRynlds_orig@_FillValue)

factor=(/2.0,5.0,10.0,20.0/)  ;; here
do ifactor=0,3

  ;;===============================
  ;; ttl
  ;;===============================
  alpha_ttl=where(abs(lambda1_ttl/lambda2_ttl).gt.factor(ifactor),\
                  alpha_ttl_orig,alpha_ttl_orig@_FillValue)
  beta_ttl=where(abs(lambda1_ttl/lambda2_ttl).lt.1.0/factor(ifactor),\
                 beta_ttl_orig,beta_ttl_orig@_FillValue)
  ;alpha_ttl=where(abs(lambda1_ttl/lambda2_ttl).lt.factor,alpha_ttl,alpha_ttl@_FillValue)
  ;beta_ttl=where(abs(lambda1_ttl/lambda2_ttl).gt.1.0/factor,beta_ttl,beta_ttl@_FillValue)
  alpha_ttl=where(ismissing(alpha_ttl),0.0,alpha_ttl)
  beta_ttl=where(ismissing(beta_ttl),0.0,beta_ttl)
  angle_ttl=alpha_ttl+beta_ttl
  angle_ttl=where(angle_ttl.eq.0.0,angle_ttl@_FillValue,angle_ttl)
  vec_1 = cos(angle_ttl/180.0*pi)
  vec_2 = sin(angle_ttl/180.0*pi)
  copy_VarMeta(angle_ttl,vec_1)
  copy_VarMeta(angle_ttl,vec_2)

  ;;PV-grad
  cosine = (abs(vec_1*pqpx + vec_2*pqpy))/   \
          (sqrt(vec_1^2.0+vec_2^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
  var = acos(cosine)*180.0/pi
  ;;;===========================================================
  wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
  printVarSummary((wrk_all))
  do jj=0,319
        wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
  end do
  do nbin=0,num_bin-1
      wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

      do jj=0,319
          wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
      end do

      frac(ifactor,nbin)=sum(wrk_bin)/sum(wrk_all)
  end do
  ;;;===========================================================

  ;;===============================
  ;; stt
  ;;===============================
  alpha_stt=where(abs(lambda1_stt/lambda2_stt).gt.factor(ifactor),\
                  alpha_stt_orig,alpha_stt_orig@_FillValue)
  beta_stt=where(abs(lambda1_stt/lambda2_stt).lt.1.0/factor(ifactor),\
                 beta_stt_orig,beta_stt_orig@_FillValue)
  ;alpha_stt=where(abs(lambda1_stt/lambda2_stt).lt.factor,alpha_stt,alpha_stt@_FillValue)
  ;beta_stt=where(abs(lambda1_stt/lambda2_stt).gt.1.0/factor,beta_stt,beta_stt@_FillValue)
  alpha_stt=where(ismissing(alpha_stt),0.0,alpha_stt)
  beta_stt=where(ismissing(beta_stt),0.0,beta_stt)
  angle_stt=alpha_stt+beta_stt
  angle_stt=where(angle_stt.eq.0.0,angle_stt@_FillValue,angle_stt)
  vec_1 = cos(angle_stt/180.0*pi)
  vec_2 = sin(angle_stt/180.0*pi)
  copy_VarMeta(angle_stt,vec_1)
  copy_VarMeta(angle_stt,vec_2)

  ;;PV-grad
  cosine = (abs(vec_1*pqpx + vec_2*pqpy))/   \
          (sqrt(vec_1^2.0+vec_2^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
  var = acos(cosine)*180.0/pi
  ;;;===========================================================
  wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
  printVarSummary((wrk_all))
  do jj=0,319
        wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
  end do
  do nbin=0,num_bin-1
      wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

      do jj=0,319
          wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
      end do

      frac(8+ifactor,nbin)=sum(wrk_bin)/sum(wrk_all)
  end do
  ;;;===========================================================

  ;;===============================
  ;; trs
  ;;===============================
  alpha_trs=where(abs(lambda1_trs/lambda2_trs).gt.factor(ifactor),\
                  alpha_trs_orig,alpha_trs_orig@_FillValue)
  beta_trs=where(abs(lambda1_trs/lambda2_trs).lt.1.0/factor(ifactor),\
                 beta_trs_orig,beta_trs_orig@_FillValue)
  ;alpha_trs=where(abs(lambda1_trs/lambda2_trs).lt.factor,alpha_trs,alpha_trs@_FillValue)
  ;beta_trs=where(abs(lambda1_trs/lambda2_trs).gt.1.0/factor,beta_trs,beta_trs@_FillValue)
  alpha_trs=where(ismissing(alpha_trs),0.0,alpha_trs)
  beta_trs=where(ismissing(beta_trs),0.0,beta_trs)
  angle_trs=alpha_trs+beta_trs
  angle_trs=where(angle_trs.eq.0.0,angle_trs@_FillValue,angle_trs)
  vec_1 = cos(angle_trs/180.0*pi)
  vec_2 = sin(angle_trs/180.0*pi)
  copy_VarMeta(angle_trs,vec_1)
  copy_VarMeta(angle_trs,vec_2)

  ;;PV-grad
  cosine = (abs(vec_1*pqpx + vec_2*pqpy))/   \
          (sqrt(vec_1^2.0+vec_2^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
  var = acos(cosine)*180.0/pi
  ;;;===========================================================
  wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
  printVarSummary((wrk_all))
  do jj=0,319
        wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
  end do
  do nbin=0,num_bin-1
      wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

      do jj=0,319
          wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
      end do

      frac(16+ifactor,nbin)=sum(wrk_bin)/sum(wrk_all)
  end do
  ;;;===========================================================

  ;;===============================
  ;; Rynlds
  ;;===============================
  alpha_Rynlds=where(abs(lambda1_Rynlds/lambda2_Rynlds).gt.factor(ifactor),\
                  alpha_Rynlds_orig,alpha_Rynlds_orig@_FillValue)
  beta_Rynlds=where(abs(lambda1_Rynlds/lambda2_Rynlds).lt.1.0/factor(ifactor),\
                 beta_Rynlds_orig,beta_Rynlds_orig@_FillValue)
  ;alpha_Rynlds=where(abs(lambda1_Rynlds/lambda2_Rynlds).lt.factor,alpha_Rynlds,alpha_Rynlds@_FillValue)
  ;beta_Rynlds=where(abs(lambda1_Rynlds/lambda2_Rynlds).gt.1.0/factor,beta_Rynlds,beta_Rynlds@_FillValue)
  alpha_Rynlds=where(ismissing(alpha_Rynlds),0.0,alpha_Rynlds)
  beta_Rynlds=where(ismissing(beta_Rynlds),0.0,beta_Rynlds)
  angle_Rynlds=alpha_Rynlds+beta_Rynlds
  angle_Rynlds=where(angle_Rynlds.eq.0.0,angle_Rynlds@_FillValue,angle_Rynlds)
  vec_1 = cos(angle_Rynlds/180.0*pi)
  vec_2 = sin(angle_Rynlds/180.0*pi)
  copy_VarMeta(angle_Rynlds,vec_1)
  copy_VarMeta(angle_Rynlds,vec_2)

  ;;PV-grad
  cosine = (abs(vec_1*pqpx + vec_2*pqpy))/   \
          (sqrt(vec_1^2.0+vec_2^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
  var = acos(cosine)*180.0/pi
  ;;;===========================================================
  wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
  printVarSummary((wrk_all))
  do jj=0,319
        wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
  end do
  do nbin=0,num_bin-1
      wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

      do jj=0,319
          wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
      end do

      frac(24+ifactor,nbin)=sum(wrk_bin)/sum(wrk_all)
  end do
  ;;;===========================================================

  ;;===============================
  ;; nonRynlds
  ;;===============================
  alpha_nonRynlds=where(abs(lambda1_nonRynlds/lambda2_nonRynlds).gt.factor(ifactor),\
                  alpha_nonRynlds_orig,alpha_nonRynlds_orig@_FillValue)
  beta_nonRynlds=where(abs(lambda1_nonRynlds/lambda2_nonRynlds).lt.1.0/factor(ifactor),\
                 beta_nonRynlds_orig,beta_nonRynlds_orig@_FillValue)
  ;alpha_nonRynlds=where(abs(lambda1_nonRynlds/lambda2_nonRynlds).lt.factor,alpha_nonRynlds,alpha_nonRynlds@_FillValue)
  ;beta_nonRynlds=where(abs(lambda1_nonRynlds/lambda2_nonRynlds).gt.1.0/factor,beta_nonRynlds,beta_nonRynlds@_FillValue)
  alpha_nonRynlds=where(ismissing(alpha_nonRynlds),0.0,alpha_nonRynlds)
  beta_nonRynlds=where(ismissing(beta_nonRynlds),0.0,beta_nonRynlds)
  angle_nonRynlds=alpha_nonRynlds+beta_nonRynlds
  angle_nonRynlds=where(angle_nonRynlds.eq.0.0,angle_nonRynlds@_FillValue,angle_nonRynlds)
  vec_1 = cos(angle_nonRynlds/180.0*pi)
  vec_2 = sin(angle_nonRynlds/180.0*pi)
  copy_VarMeta(angle_nonRynlds,vec_1)
  copy_VarMeta(angle_nonRynlds,vec_2)

  ;;PV-grad
  cosine = (abs(vec_1*pqpx + vec_2*pqpy))/   \
          (sqrt(vec_1^2.0+vec_2^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
  var = acos(cosine)*180.0/pi
  ;;;===========================================================
  wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
  printVarSummary((wrk_all))
  do jj=0,319
        wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
  end do
  do nbin=0,num_bin-1
      wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

      do jj=0,319
          wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
      end do

      frac(32+ifactor,nbin)=sum(wrk_bin)/sum(wrk_all)
  end do
  ;;;===========================================================


end do  ;;loop for ifactor

;;;===========================================================
factor2=(/5.0,2.0,1.25,1.1/)  ;; here should be from large to small
do ifactor=0,3

  ;;===============================
  ;; ttl
  ;;===============================
  alpha_ttl=where((abs(lambda1_ttl/lambda2_ttl).lt.factor2(ifactor)).and.(abs(lambda1_ttl/lambda2_ttl).gt.1.0),\
                alpha_ttl_orig,alpha_ttl_orig@_FillValue)
  beta_ttl=where((abs(lambda1_ttl/lambda2_ttl).gt.1.0/factor2(ifactor)).and.(abs(lambda1_ttl/lambda2_ttl).lt.1.0),\
                beta_ttl_orig,beta_ttl_orig@_FillValue)
  alpha_ttl=where(ismissing(alpha_ttl),0.0,alpha_ttl)
  beta_ttl=where(ismissing(beta_ttl),0.0,beta_ttl)
  angle_ttl=alpha_ttl+beta_ttl
  angle_ttl=where(angle_ttl.eq.0.0,angle_ttl@_FillValue,angle_ttl)
  vec_1 = cos(angle_ttl/180.0*pi)
  vec_2 = sin(angle_ttl/180.0*pi)
  copy_VarMeta(angle_ttl,vec_1)
  copy_VarMeta(angle_ttl,vec_2)

  ;;PV-grad
  cosine = (abs(vec_1*pqpx + vec_2*pqpy))/   \
          (sqrt(vec_1^2.0+vec_2^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
  var = acos(cosine)*180.0/pi
  ;;;===========================================================
  wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
  printVarSummary((wrk_all))
  do jj=0,319
        wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
  end do
  do nbin=0,num_bin-1
      wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

      do jj=0,319
          wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
      end do

      frac(4+ifactor,nbin)=sum(wrk_bin)/sum(wrk_all)
  end do
  ;;;===========================================================

  ;;===============================
  ;; stt
  ;;===============================
  alpha_stt=where((abs(lambda1_stt/lambda2_stt).lt.factor2(ifactor)).and.(abs(lambda1_stt/lambda2_stt).gt.1.0),\
                alpha_stt_orig,alpha_stt_orig@_FillValue)
  beta_stt=where((abs(lambda1_stt/lambda2_stt).gt.1.0/factor2(ifactor)).and.(abs(lambda1_stt/lambda2_stt).lt.1.0),\
                beta_stt_orig,beta_stt_orig@_FillValue)
  alpha_stt=where(ismissing(alpha_stt),0.0,alpha_stt)
  beta_stt=where(ismissing(beta_stt),0.0,beta_stt)
  angle_stt=alpha_stt+beta_stt
  angle_stt=where(angle_stt.eq.0.0,angle_stt@_FillValue,angle_stt)
  vec_1 = cos(angle_stt/180.0*pi)
  vec_2 = sin(angle_stt/180.0*pi)
  copy_VarMeta(angle_stt,vec_1)
  copy_VarMeta(angle_stt,vec_2)

  ;;PV-grad
  cosine = (abs(vec_1*pqpx + vec_2*pqpy))/   \
          (sqrt(vec_1^2.0+vec_2^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
  var = acos(cosine)*180.0/pi
  ;;;===========================================================
  wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
  printVarSummary((wrk_all))
  do jj=0,319
        wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
  end do
  do nbin=0,num_bin-1
      wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

      do jj=0,319
          wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
      end do

      frac(12+ifactor,nbin)=sum(wrk_bin)/sum(wrk_all)
  end do
  ;;;===========================================================

  ;;===============================
  ;; trs
  ;;===============================
  alpha_trs=where((abs(lambda1_trs/lambda2_trs).lt.factor2(ifactor)).and.(abs(lambda1_trs/lambda2_trs).gt.1.0),\
                alpha_trs_orig,alpha_trs_orig@_FillValue)
  beta_trs=where((abs(lambda1_trs/lambda2_trs).gt.1.0/factor2(ifactor)).and.(abs(lambda1_trs/lambda2_trs).lt.1.0),\
                beta_trs_orig,beta_trs_orig@_FillValue)
  alpha_trs=where(ismissing(alpha_trs),0.0,alpha_trs)
  beta_trs=where(ismissing(beta_trs),0.0,beta_trs)
  angle_trs=alpha_trs+beta_trs
  angle_trs=where(angle_trs.eq.0.0,angle_trs@_FillValue,angle_trs)
  vec_1 = cos(angle_trs/180.0*pi)
  vec_2 = sin(angle_trs/180.0*pi)
  copy_VarMeta(angle_trs,vec_1)
  copy_VarMeta(angle_trs,vec_2)

  ;;PV-grad
  cosine = (abs(vec_1*pqpx + vec_2*pqpy))/   \
          (sqrt(vec_1^2.0+vec_2^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
  var = acos(cosine)*180.0/pi
  ;;;===========================================================
  wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
  printVarSummary((wrk_all))
  do jj=0,319
        wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
  end do
  do nbin=0,num_bin-1
      wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

      do jj=0,319
          wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
      end do

      frac(20+ifactor,nbin)=sum(wrk_bin)/sum(wrk_all)
  end do
  ;;;===========================================================

  ;;===============================
  ;; Rynlds
  ;;===============================
  alpha_Rynlds=where((abs(lambda1_Rynlds/lambda2_Rynlds).lt.factor2(ifactor)).and.(abs(lambda1_Rynlds/lambda2_Rynlds).gt.1.0),\
                alpha_Rynlds_orig,alpha_Rynlds_orig@_FillValue)
  beta_Rynlds=where((abs(lambda1_Rynlds/lambda2_Rynlds).gt.1.0/factor2(ifactor)).and.(abs(lambda1_Rynlds/lambda2_Rynlds).lt.1.0),\
                beta_Rynlds_orig,beta_Rynlds_orig@_FillValue)
  alpha_Rynlds=where(ismissing(alpha_Rynlds),0.0,alpha_Rynlds)
  beta_Rynlds=where(ismissing(beta_Rynlds),0.0,beta_Rynlds)
  angle_Rynlds=alpha_Rynlds+beta_Rynlds
  angle_Rynlds=where(angle_Rynlds.eq.0.0,angle_Rynlds@_FillValue,angle_Rynlds)
  vec_1 = cos(angle_Rynlds/180.0*pi)
  vec_2 = sin(angle_Rynlds/180.0*pi)
  copy_VarMeta(angle_Rynlds,vec_1)
  copy_VarMeta(angle_Rynlds,vec_2)

  ;;PV-grad
  cosine = (abs(vec_1*pqpx + vec_2*pqpy))/   \
          (sqrt(vec_1^2.0+vec_2^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
  var = acos(cosine)*180.0/pi
  ;;;===========================================================
  wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
  printVarSummary((wrk_all))
  do jj=0,319
        wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
  end do
  do nbin=0,num_bin-1
      wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

      do jj=0,319
          wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
      end do

      frac(28+ifactor,nbin)=sum(wrk_bin)/sum(wrk_all)
  end do
  ;;;===========================================================

  ;;===============================
  ;; nonRynlds
  ;;===============================
  alpha_nonRynlds=where((abs(lambda1_nonRynlds/lambda2_nonRynlds).lt.factor2(ifactor)).and.(abs(lambda1_nonRynlds/lambda2_nonRynlds).gt.1.0),\
                alpha_nonRynlds_orig,alpha_nonRynlds_orig@_FillValue)
  beta_nonRynlds=where((abs(lambda1_nonRynlds/lambda2_nonRynlds).gt.1.0/factor2(ifactor)).and.(abs(lambda1_nonRynlds/lambda2_nonRynlds).lt.1.0),\
                beta_nonRynlds_orig,beta_nonRynlds_orig@_FillValue)
  alpha_nonRynlds=where(ismissing(alpha_nonRynlds),0.0,alpha_nonRynlds)
  beta_nonRynlds=where(ismissing(beta_nonRynlds),0.0,beta_nonRynlds)
  angle_nonRynlds=alpha_nonRynlds+beta_nonRynlds
  angle_nonRynlds=where(angle_nonRynlds.eq.0.0,angle_nonRynlds@_FillValue,angle_nonRynlds)
  vec_1 = cos(angle_nonRynlds/180.0*pi)
  vec_2 = sin(angle_nonRynlds/180.0*pi)
  copy_VarMeta(angle_nonRynlds,vec_1)
  copy_VarMeta(angle_nonRynlds,vec_2)

  ;;PV-grad
  cosine = (abs(vec_1*pqpx + vec_2*pqpy))/   \
          (sqrt(vec_1^2.0+vec_2^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
  var = acos(cosine)*180.0/pi
  ;;;===========================================================
  wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
  printVarSummary((wrk_all))
  do jj=0,319
        wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
  end do
  do nbin=0,num_bin-1
      wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

      do jj=0,319
          wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
      end do

      frac(36+ifactor,nbin)=sum(wrk_bin)/sum(wrk_all)
  end do
  ;;;===========================================================

end do  ;;loop for ifactor



;wks = gsn_open_wks("pdf", pic_dir+pic_name)
wks = gsn_open_wks("png", pic_dir+pic_name)
;gsn_define_colormap(wks, "MPL_Greys")

res = True
res@gsnDraw               = False
res@gsnFrame              = False
res@vpWidthF              = 0.4
res@vpHeightF             = 0.4

res@trXMinF               = 0.0
res@trXMaxF               = 90.0

; res@gsnXYBarChart         = True
; res@gsnXYBarChartBarWidth = 1.0           ; change bar widths
res@tmXBLabelFontHeightF  = 0.018
res@tmYLLabelFontHeightF  = 0.018
; res@gsnRightString        = ""
; res@gsnXYBarChartColors = "purple"
; res@gsnXYBarChartOutlineThicknessF = 0.001


res@pmLegendWidthF=0.09
res@pmLegendHeightF=0.15
res@pmLegendOrthogonalPosF=-0.9
res@pmLegendParallelPosF=0.25


do ivar=0,4

  res@trYMinF               = 0.0
  res@trYMaxF               = 13.0

  res@xyLineThicknesses=(/3,3,3,3,2,2,2,2/)
  res@xyLineColors=(/"black","blue","green","red","black","blue","green","red"/)
  res@xyDashPatterns=(/0,0,0,0,2,2,2,2/)

  if(ivar.eq.0)then
    res@pmLegendDisplayMode="Always"
    res@xyExplicitLegendLabels=(/"alpha=2","alpha=5","alpha=10","alpha=20",\
                                "gamma=5","gamma=2","gamma=1.25","gamma=1.1"/)

    res@lgLabelFontHeightF=0.014
  end if

  if((ivar.eq.1) .or. (ivar.eq.2) .or. (ivar.eq.3) .or. (ivar.eq.4))then
    res@pmLegendDisplayMode="NoCreate"
  end if
    ;pp = sqrt(frac(ivar,:)*100)
    pp = frac(ivar*8:ivar*8+7,:)*100
    plot(ivar) = gsn_csm_xy(wks,x,pp,res)
end do



pres = True
pres@txString = ""
pres@txFontHeightF = 0.015
;pres@gsnPanelLabelBar = True
pres@gsnPanelFigureStrings = (/"(a) ttl", \
                              "(b) stt",\
                              "(c) trs",\
                              "(d)Rynlds",\
                              "(e)non-Rynlds"/)
pres@gsnPanelFigureStringsFontHeightF = 0.012
pres@amJust = "Topleft"
gsn_panel(wks,plot,(/2,3/),pres)



end
