load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begin

;;---------------------------------------------;;
res = True
res@gsnDraw=False
res@gsnFrame=False
res@gsnAddCyclic=False
res@gsnCenterString=""
res@gsnLeftStringFontHeightF = 0.012
res@gsnRightString=""
res@gsnLeftString=""
res@mpCenterLonF=180
res@mpMaxLonF=359
res@mpMinLonF=1
res@mpMaxLatF=-25
res@mpMinLatF=-75
res@mpMonoFillColor = True
res@mpFillColor = "gray79"

res@cnFillOn=True
res@cnLinesOn=False
res@cnFillMode = "RasterFill"
res@lbLabelBarOn = True
res@lbLabelFontHeightF = 0.01
res@lbLabelStride = 1
res@pmLabelBarOrthogonalPosF=0.11
res@tmXBLabelFontHeightF=0.0075
res@tmXBLabelDeltaF=-0.5
res@tmYLLabelFontHeightF=0.0075
res@tmYLLabelDeltaF=-0.5
;res@cnLineThicknessF=0.1
res@lbLabelBarOn=False

res1=res
res2=res
resc=res
resc@cnFillOn=False
resc@cnLinesOn=True
resc@cnLevelSelectionMode = "ExplicitLevels"
resc@cnLevels = (/1.0/)
resc@cnLineThicknessF = 30.0
resc@cnLineColor = "black"
resc@cnLineLabelsOn = False
resc@cnInfoLabelOn = False

pres = True
pres@txString = ""
pres@gsnPanelLabelBar = True
;pres@gsnPanelFigureStrings = (/"a","b","c","d","e"/)
;pres@gsnPanelFigureStringsFontHeightF=0.01
;pres@amJust = "Topleft"
pres@lbBoxLinesOn=False
pres@lbLabelFontHeightF = 0.012
pres@lbLabelStride = 25
pres@pmLabelBarWidthF = 0.8
pres@pmLegendHeightF = 0.6
pres@pmLabelBarParallelPosF = -0.026
;;---------------------------------------------;;
values = new(201,double)
aa = fspan(0,4,101)
values(101:200)=10^aa(1:100)
bb = fspan(4,0,101)
values(0:99)=10^bb(0:99)
values(100)=0.0
values(0:99)=-values(0:99)
;print(values)

fill = new(202,integer)
fill_wrk = fspan(25,125,101)
fill(0:100) = floattoint(fill_wrk)
fill_wrk = fspan(130,230,101)
fill(101:201) = floattoint(fill_wrk)
;print(fill)
;;---------------------------------------------;;

dir = "../SOSE/"
base = new(5,graphic)
wks_type="png"
wks_type@wkWidth=10000
wks_type@wkHeight=10000
wks=gsn_open_wks(wks_type,"./figureC2")

;;---------------------------------------------;;
;res@cnFillPalette="MPL_coolwarm"
res@cnFillPalette="ncl_default"
res@cnLevelSelectionMode="ExplicitLevels"
res@cnLevels       = values
res@cnFillColors       = fill
; res@cnLevelSelectionMode="ExplicitLevels"
; res@cnLevels       = (/-100000,-10000,-1000,-100,-10,-1,0,1,10,100,1000,10000,100000/)
; res@cnFillColors       = (/10,20,35,50,65,80,110,    140,153,170,190,205,217,230/)
; var_max=10000
; var_min=-10000
; spa=(var_max-var_min)/200
; res@cnLevelSelectionMode="ManualLevels"
; res@cnMaxLevelValF=var_max
; res@cnMinLevelValF=var_min
; res@cnLevelSpacingF=spa
;;---------------------------------------------;;

f=addfile(dir+"zz_topo/outcrop-counter-sose-2008.nc", "r")
var=f->daynum(0,2,:,0:2159)
var = (var/73.0)*100.0
plot=gsn_csm_contour(wks,var,resc)
;;---------------------------------------------;;

f1=addfile(dir+"flux/F-vq-sgs-2deg-1yr-2008.nc","r")
var1=f1->flux(0,2,:,0:2159)
var1=var1*1e12
;print(var1(100:110,1000))

res@gsnLeftString="(a) flux-sfs-ttl"
base(0)=gsn_csm_contour_map(wks,var1,res)
overlay(base(0), plot)

delete([/f1,var1/])

f1=addfile(dir+"flux/F-vq-stationary-2deg-1yr-2008.nc","r")
var1=f1->flux(0,2,:,0:2159)
var1=var1*1e12

f2=addfile(dir+"flux/F-vq-transient-2deg-1yr-2008.nc","r")
var2=f2->flux(0,2,:,0:2159)
var2=var2*1e12

res@gsnLeftString="(b) flux-sfs-stt"
base(1)=gsn_csm_contour_map(wks,var1,res)

res@gsnLeftString="(c) flux-sfs-trs"
base(2)=gsn_csm_contour_map(wks,var2,res)

delete([/f1,f2,var1,var2/])


f1=addfile(dir+"flux/F-vq-Rynlds-2deg-1yr-2008.nc","r")
var1=f1->flux(0,2,:,0:2159)
var1=var1*1e12

f2=addfile(dir+"flux/F-vq-nonRynlds-2deg-1yr-2008.nc","r")
var2=f2->flux(0,2,:,0:2159)
var2=var2*1e12

res@gsnLeftString="(d) flux-Rynlds-ttl"
base(3)=gsn_csm_contour_map(wks,var1,res)

res@gsnLeftString="(e) flux-nonRynlds-ttl"
base(4)=gsn_csm_contour_map(wks,var2,res)

delete([/f1,f2,var1,var2/])


gsn_panel(wks,base,(/5,1/),pres)

; draw(base(0))
; frame(wks)

end
