load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begin

dir = "../SOSE/flux/"
pic_dir = "./"
varname = "flux"
filename1 = (/"F-vq-sgs-1deg-1yr-2008.nc","F-vq-stationary-1deg-1yr-2008.nc","F-vq-transient-1deg-1yr-2008.nc",\
            "F-vq-Rynlds-1deg-1yr-2008.nc","stationary-vq-Rynlds-1deg-1yr-2008.nc","transient-vq-Rynlds-1deg-1yr-2008.nc",\
            "F-vq-nonRynlds-1deg-1yr-2008.nc","stationary-vq-nonRynlds-1deg-1yr-2008.nc","transient-vq-nonRynlds-1deg-1yr-2008.nc"/)
filename2 = (/"F-vq-sgs-2deg-1yr-2008.nc","F-vq-stationary-2deg-1yr-2008.nc","F-vq-transient-2deg-1yr-2008.nc",\
            "F-vq-Rynlds-2deg-1yr-2008.nc","stationary-vq-Rynlds-2deg-1yr-2008.nc","transient-vq-Rynlds-2deg-1yr-2008.nc",\
            "F-vq-nonRynlds-2deg-1yr-2008.nc","stationary-vq-nonRynlds-2deg-1yr-2008.nc","transient-vq-nonRynlds-2deg-1yr-2008.nc"/)
filename3 = (/"F-vq-sgs-3deg-1yr-2008.nc","F-vq-stationary-3deg-1yr-2008.nc","F-vq-transient-3deg-1yr-2008.nc",\
            "F-vq-Rynlds-3deg-1yr-2008.nc","stationary-vq-Rynlds-3deg-1yr-2008.nc","transient-vq-Rynlds-3deg-1yr-2008.nc",\
            "F-vq-nonRynlds-3deg-1yr-2008.nc","stationary-vq-nonRynlds-3deg-1yr-2008.nc","transient-vq-nonRynlds-3deg-1yr-2008.nc"/)
pic_name = "figureC3"  ;;(-50,50)

bin_start=-10.0
num_bin=200
bin_int=20.0/num_bin
num_lev=1
pi=3.14159

wrk_bin=new((/320,2160/),double)
wrk_all=new((/320,2160/),double)
frac=new((/27,num_bin/),double) ;;9 vars
x = fspan(-9.95,9.95,num_bin)
plot = new(9,graphic)

wks_type="png"
wks_type@wkWidth=2000
wks_type@wkHeight=2000
wks = gsn_open_wks(wks_type, pic_dir+pic_name)

f=addfile(dir+"zz_topo/outcrop-counter-sose-2008.nc", "r")
daynum=f->daynum(0,2,:,0:2159)
daynum = (daynum/73.0)*100.0

do ivar=0,8
;;=============================================================
    f=addfile(dir+filename1(ivar),"r")
    lat=f->lat
    var=f->$varname$(0,2,:,0:2159)  ;;3680
    var=var*1e9
    print(filename1(ivar))
    ;print(dimsizes(var))
    var_shape=dimsizes(var)
    print(max(var))
    print(min(var))

    var = where(abs(daynum).lt.1.0, var, var@_FillValue)

    wrk_all = where(abs(var).lt.1e+10, 1, 0)
    ;printVarSummary((wrk_all))
    ;print(var(0,0))

    do jj=0,319
          wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    do nbin=0,num_bin-1
        wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

        do jj=0,319
            wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
        end do

        frac(ivar*3,nbin)=sum(wrk_bin)/sum(wrk_all)
    end do
;;=============================================================
end do ;;ivar loop

do ivar=0,8
;;=============================================================
    f=addfile(dir+filename2(ivar),"r")
    lat=f->lat
    var=f->$varname$(0,2,:,0:2159)  ;;3680
    var=var*1e9
    ;print(dimsizes(var))
    var_shape=dimsizes(var)
    print(max(var))

    var = where(abs(daynum).lt.1.0, var, var@_FillValue)

    wrk_all = where(abs(var).lt.1e+10, 1, 0)
    ;printVarSummary((wrk_all))

    do jj=0,319
          wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    do nbin=0,num_bin-1
        wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

        do jj=0,319
            wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
        end do

        frac(ivar*3+1,nbin)=sum(wrk_bin)/sum(wrk_all)
    end do
;;=============================================================
end do ;;ivar loop

do ivar=0,8
;;=============================================================
    f=addfile(dir+filename3(ivar),"r")
    lat=f->lat
    var=f->$varname$(0,2,:,0:2159)  ;;3680
    var=var*1e9
    ;print(dimsizes(var))
    var_shape=dimsizes(var)
    print(max(var))

    var = where(abs(daynum).lt.1.0, var, var@_FillValue)

    wrk_all = where(abs(var).lt.1e+10, 1, 0)
    ;printVarSummary((wrk_all))

    do jj=0,319
          wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    do nbin=0,num_bin-1
        wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

        do jj=0,319
            wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
        end do

        frac(ivar*3+2,nbin)=sum(wrk_bin)/sum(wrk_all)
    end do
;;=============================================================
end do ;;ivar loop


res = True
res@gsnDraw               = False
res@gsnFrame              = False

res@vpWidthF              = 0.75
res@vpHeightF             = 0.45

res@trXMinF               = -4.0
res@trXMaxF               = 4.0
res@trYMinF               = 0.3
res@trYMaxF               = 3.0

res@tmXBLabelFontHeightF  = 0.032
res@tmYLLabelFontHeightF  = 0.032
res@pmLegendWidthF=0.09
res@pmLegendHeightF=0.15
res@pmLegendOrthogonalPosF=-0.9
res@pmLegendParallelPosF=0.15


do ivar=0,8

  res@xyLineThicknesses=(/5,5,5/)
  res@xyLineColors=(/"blue","green","red"/)
  res@xyDashPatterns=(/0,0,0/)

  if(ivar.eq.0)then
    res@pmLegendDisplayMode="Always"
    res@xyExplicitLegendLabels=(/"1deg","2deg","3deg"/)
    res@lgLabelFontHeightF=0.032
  end if

  if(ivar.ne.0)then
    res@pmLegendDisplayMode="NoCreate"
  end if

    pp = sqrt(sqrt(frac(ivar*3:ivar*3+2,:)*100))
    plot(ivar) = gsn_csm_xy(wks,x,pp,res)
end do


pres = True
pres@txString = ""
;pres@txFontHeightF = 0.018
;pres@gsnPanelLabelBar = True
pres@gsnPanelFigureStrings = (/"(a) ttl-sfs",     "(b) stt-sfs",      "(c) trs-sfs",\
                              "(d) ttl-Rynlds",     "(e) stt-Rynlds",     "(f) trs-Rynlds",\
                              "(g) ttl-nonRynlds",  "(h) stt-nonRynlds",  "(i) trs-nonRynlds"/)
pres@gsnPanelFigureStringsFontHeightF = 0.011
pres@amJust = "Topleft"
gsn_panel(wks,plot,(/3,3/),pres)



end
