load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begin

dir = "../SOSE/"
fig_dir = "./"

vname = (/"lambda1","lambda2"/)
filename_1 = (/"K_tensor-1deg/eigen/lambda1-sgs-size3-1deg-1yr-2008.nc",\
               "K_tensor-2deg/eigen/lambda1-sgs-size3-2deg-1yr-2008.nc",\
               "K_tensor-3deg/eigen/lambda1-sgs-size3-3deg-1yr-2008.nc",\
               "K_tensor-1deg/eigen/lambda1-stationary-size3-1deg-1yr-2008.nc",\
               "K_tensor-2deg/eigen/lambda1-stationary-size3-2deg-1yr-2008.nc",\ 
               "K_tensor-3deg/eigen/lambda1-stationary-size3-3deg-1yr-2008.nc",\
               "K_tensor-1deg/eigen/lambda1-transient-size3-1deg-1yr-2008.nc",\
               "K_tensor-2deg/eigen/lambda1-transient-size3-2deg-1yr-2008.nc",\
               "K_tensor-3deg/eigen/lambda1-transient-size3-3deg-1yr-2008.nc",\
               "K_tensor-1deg/eigen/lambda1-Rynlds-size3-1deg-1yr-2008.nc",\
               "K_tensor-2deg/eigen/lambda1-Rynlds-size3-2deg-1yr-2008.nc",\
               "K_tensor-3deg/eigen/lambda1-Rynlds-size3-3deg-1yr-2008.nc",\
               "K_tensor-1deg/eigen/lambda1-nonRynlds-size3-1deg-1yr-2008.nc",\
               "K_tensor-2deg/eigen/lambda1-nonRynlds-size3-2deg-1yr-2008.nc",\
               "K_tensor-3deg/eigen/lambda1-nonRynlds-size3-3deg-1yr-2008.nc"/)
filename_2 = (/"K_tensor-1deg/eigen/lambda2-sgs-size3-1deg-1yr-2008.nc",\
               "K_tensor-2deg/eigen/lambda2-sgs-size3-2deg-1yr-2008.nc",\
               "K_tensor-3deg/eigen/lambda2-sgs-size3-3deg-1yr-2008.nc",\
               "K_tensor-1deg/eigen/lambda2-stationary-size3-1deg-1yr-2008.nc",\
               "K_tensor-2deg/eigen/lambda2-stationary-size3-2deg-1yr-2008.nc",\ 
               "K_tensor-3deg/eigen/lambda2-stationary-size3-3deg-1yr-2008.nc",\
               "K_tensor-1deg/eigen/lambda2-transient-size3-1deg-1yr-2008.nc",\
               "K_tensor-2deg/eigen/lambda2-transient-size3-2deg-1yr-2008.nc",\
               "K_tensor-3deg/eigen/lambda2-transient-size3-3deg-1yr-2008.nc",\
               "K_tensor-1deg/eigen/lambda2-Rynlds-size3-1deg-1yr-2008.nc",\
               "K_tensor-2deg/eigen/lambda2-Rynlds-size3-2deg-1yr-2008.nc",\
               "K_tensor-3deg/eigen/lambda2-Rynlds-size3-3deg-1yr-2008.nc",\
               "K_tensor-1deg/eigen/lambda2-nonRynlds-size3-1deg-1yr-2008.nc",\
               "K_tensor-2deg/eigen/lambda2-nonRynlds-size3-2deg-1yr-2008.nc",\
               "K_tensor-3deg/eigen/lambda2-nonRynlds-size3-3deg-1yr-2008.nc"/)
fig_name = "figureC6"

num_lev=1
pi=3.14159
num_bin_x=100
num_bin_y=100
num_bin=num_bin_x
wrk_bin=new((/320,2160/),double)
wrk_all=new((/320,2160/),double)
frac=new((/15,num_bin_x,num_bin_y/),double) ;;15 vars
plot = new(15,graphic)
xx1=fspan(0.0,99.0,12)
yy1=xx1*0.0+49.5
yy2=fspan(0.0,99.0,12)
xx2=yy2*0.0+49.5

f=addfile(dir+"zz_topo/outcrop-counter-sose-2008.nc", "r")
daynum=f->daynum(0,2,:,0:2159)
daynum = (daynum/73.0)*100.0

do ivar=0,14
    print("ivar="+ivar)
 
    f1=addfile(dir+filename_1(ivar),"r")
    lat=f1->lat
    lambda1=f1->$vname(0)$(0,2,:,0:2159)  ;;3680

    f2=addfile(dir+filename_2(ivar),"r")
    lat=f2->lat
    lambda2=f2->$vname(1)$(0,2,:,0:2159)  ;;3680

    print(dimsizes(lambda1))
    var_shape=dimsizes(lambda1)

    lambda1 = where(abs(daynum).lt.1.0, lambda1, lambda1@_FillValue)
    lambda2 = where(abs(daynum).lt.1.0, lambda2, lambda2@_FillValue)
    print(max(lambda1))


    bin_start=-30000.0
    bin_int=60000.0/num_bin


    wrk_all = where((abs(lambda1).lt.1e+10).and.(abs(lambda2).lt.1e+10), 1, 0)
    printVarSummary((wrk_all))

    do jj=0,319
          wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    do nbin_x=0,num_bin_x-1
        do nbin_y=0,num_bin_y-1

        wrk_bin = where((lambda1.gt.(bin_start+nbin_x*bin_int) .and. lambda1.lt.(bin_start+(nbin_x+1)*bin_int))\
                        .and. (lambda2.gt.(bin_start+nbin_y*bin_int) .and. lambda2.lt.(bin_start+(nbin_y+1)*bin_int))\
                        ,1,0)

        do jj=0,319
            wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
        end do

        frac(ivar,nbin_y,nbin_x)=sum(wrk_bin)/sum(wrk_all)

        end do
    end do
end do

fout=addfile(fig_dir+"SOSE-degs-lambdas-joint-pdf.nc","c")
fout->frac = frac

;;=====================================================
wks_type="png"
wks_type@wkWidth=3000
wks_type@wkHeight=3000
wks = gsn_open_wks(wks_type, fig_dir+fig_name)
;gsn_define_colormap(wks, "MPL_Greys")
;gsn_define_colormap(wks, "WhiteYellowOrangeRed")
gsn_define_colormap(wks, "WhiteBlueGreenYellowRed")

ff=addfile(fig_dir+"SOSE-degs-lambdas-joint-pdf.nc","r")
frac_wrk=ff->frac  ;;3680
frac_wrk = frac_wrk*100
;frac_wrk = where(frac_wrk.lt.0.01, -0.01, frac_wrk)
printVarSummary((frac_wrk))
; print(frac_wrk(0,:,:))
; print(frac_wrk(1,:,:))

do ivar=0,14

    res = True
    res@gsnDraw               = False
    res@gsnFrame              = False

    res@cnFillOn=True
    res@cnLinesOn=False
    res@cnLineLabelsOn=False
    res@cnInfoLabelOn=False

    res@vpWidthF              = 0.5
    res@vpHeightF             = 0.5

    res@trXMinF               = -0.5
    res@trXMaxF               = 99.5
    res@trYMinF               = -0.5
    res@trYMaxF               = 99.5

    res@tmXBLabelFontHeightF=0.002
    res@tmXBLabelDeltaF=-0.5
    res@tmYLLabelFontHeightF=0.002
    res@tmYLLabelDeltaF=-0.5

    res@tmXBMode="Explicit"
    res@tmXBValues=(/-0.5,24.5,49.5,74.5,99.5/)
    res@tmYLMode="Explicit"
    res@tmYLValues=(/-0.5,24.5,49.5,74.5,99.5/)

    res@tmXBLabels=(/"-3E4","-1.5E4","0","1.5E4","3E4"/)
    res@tmYLLabels=(/"-3E4","-1.5E4","0","1.5E4","3E4"/)

    res@tmXTOn="False"
    res@tmXBLabelFontHeightF  = 0.025
    ; res@tmXBLabelAngleF = 30

    ; res@tmXTOn=False
    ; res@tmYROn=False
    res@tmYLLabelFontHeightF  = 0.025

    res@gsnRightString        = ""
    ;res@tiYAxisString         = "frequency"
    ;res@tiYAxisFontHeightF = 0.02

    ; res@cnLevelSelectionMode="ManualLevels"
    ; res@cnMinLevelValF=0.0
    ; res@cnMaxLevelValF=0.3
    ; res@cnLevelSpacingF=0.01
    res@cnLevelSelectionMode="ExplicitLevels"
  res@cnLevels     = (/0.01, 0.05, 0.1, 0.15, 0.2, 0.25, 0.3, 0.4, 0.5, 0.8, 1.0/)
  res@cnFillColors = (/2,50,70,90,110,130,150,170,190,210,230,250/)


    ;res@gsnYRefLine = 0.0
    ;res@gsnYRefLine = 10.0
    res@cnFillMode = "RasterFill"
    res@lbLabelBarOn = False

    if(ivar.le.4)then
      pp = frac_wrk(ivar*3,:,:)
      plot(ivar) = gsn_csm_contour(wks, pp, res)
    end if

    if((ivar.ge.5) .and. (ivar.le.9))then
      pp = frac_wrk((ivar-5)*3+1,:,:)
      plot(ivar) = gsn_csm_contour(wks, pp, res)
    end if

    if((ivar.ge.10) .and. (ivar.le.14))then
      pp = frac_wrk((ivar-10)*3+2,:,:)
      plot(ivar) = gsn_csm_contour(wks, pp, res)
    end if

end do ;;ivar loop


lnres=True
lnres@gsLineColor="black"
lnres@gsLineThicknessF=4.0
lnres@gsLineDashPattern=2
dum1 = gsn_add_polyline(wks, plot(0), xx1, yy1, lnres)
dum2 = gsn_add_polyline(wks, plot(0), xx2, yy2, lnres)
dum3 = gsn_add_polyline(wks, plot(1), xx1, yy1, lnres)
dum4 = gsn_add_polyline(wks, plot(1), xx2, yy2, lnres)
dum5 = gsn_add_polyline(wks, plot(2), xx1, yy1, lnres)
dum6 = gsn_add_polyline(wks, plot(2), xx2, yy2, lnres)
dum7 = gsn_add_polyline(wks, plot(3), xx1, yy1, lnres)
dum8 = gsn_add_polyline(wks, plot(3), xx2, yy2, lnres)
dum9 = gsn_add_polyline(wks, plot(4), xx1, yy1, lnres)
dum10 = gsn_add_polyline(wks, plot(4), xx2, yy2, lnres)
dum11 = gsn_add_polyline(wks, plot(5), xx1, yy1, lnres)
dum12 = gsn_add_polyline(wks, plot(5), xx2, yy2, lnres)
dum13 = gsn_add_polyline(wks, plot(6), xx1, yy1, lnres)
dum14 = gsn_add_polyline(wks, plot(6), xx2, yy2, lnres)
dum15 = gsn_add_polyline(wks, plot(7), xx1, yy1, lnres)
dum16 = gsn_add_polyline(wks, plot(7), xx2, yy2, lnres)
dum17 = gsn_add_polyline(wks, plot(8), xx1, yy1, lnres)
dum18 = gsn_add_polyline(wks, plot(8), xx2, yy2, lnres)
dum19 = gsn_add_polyline(wks, plot(9), xx1, yy1, lnres)
dum20 = gsn_add_polyline(wks, plot(9), xx2, yy2, lnres)
dum21 = gsn_add_polyline(wks, plot(10), xx1, yy1, lnres)
dum22 = gsn_add_polyline(wks, plot(10), xx2, yy2, lnres)
dum23 = gsn_add_polyline(wks, plot(11), xx1, yy1, lnres)
dum24 = gsn_add_polyline(wks, plot(11), xx2, yy2, lnres)
dum25 = gsn_add_polyline(wks, plot(12), xx1, yy1, lnres)
dum26 = gsn_add_polyline(wks, plot(12), xx2, yy2, lnres)
dum27 = gsn_add_polyline(wks, plot(13), xx1, yy1, lnres)
dum28 = gsn_add_polyline(wks, plot(13), xx2, yy2, lnres)
dum29 = gsn_add_polyline(wks, plot(14), xx1, yy1, lnres)
dum30 = gsn_add_polyline(wks, plot(14), xx2, yy2, lnres)


pres = True
;pres@txString = "joint pdf(*100) of lambdas"
pres@txFontHeightF = 0.015
;pres@gsnPanelLabelBar = True
pres@gsnPanelFigureStrings = (/"(a) 1deg-ttl-sfs",   "(b) 1deg-stt-sfs",      "(c) 1deg-trs-sfs",  \
                              "(d) 1deg-ttl-Rynlds", "(e) 1deg-ttl-nonRynlds",                     \
                              "(f) 2deg-ttl-sfs",    "(g) 2deg-stt-sfs",      "(h) 2deg-trs-sfs",  \
                              "(i) 2deg-ttl-Rynlds", "(j) 2deg-ttl-nonRynlds",                     \
                              "(k) 3deg-ttl-sfs",    "(l) 3deg-stt-sfs",                           \
                              "(m) 3deg-trs-sfs",    "(n) 3deg-ttl-Rynlds",    "(o) 3deg-ttl-nonRynlds"/)
pres@gsnPanelFigureStringsFontHeightF = 0.009
pres@amJust = "Topleft"
pres@gsnPanelLabelBar = True
pres@lbLabelFontHeightF = 0.012
pres@lbLabelStride = 1

gsn_panel(wks,plot,(/3,5/),pres)



end
