load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begin

dir = "../SOSE/K_tensor-2deg/eigen/"
fig_dir = "./"
fig_name = "figureC7"

;;--------------------------------------------;;
res = True
res@gsnDraw=False
res@gsnFrame=False
res@gsnAddCyclic=False
res@gsnCenterString=""
res@gsnLeftStringFontHeightF = 0.03
res@gsnRightString=""
res@cnFillOn=True
res@cnLinesOn=False
res@cnFillMode = "RasterFill"
res@cnRasterSmoothingOn = True
res@lbLabelBarOn = True
res@lbBoxLinesOn=False
res@lbLabelFontHeightF = 0.02
res@mpMaxLonF=110
res@mpMinLonF=50
res@mpMaxLatF=-35
res@mpMinLatF=-65
res@mpMonoFillColor = True
res@mpFillColor = "gray79"
res@tmXBLabelFontHeightF=0.02
res@tmXBLabelDeltaF=-0.5
res@tmYLLabelFontHeightF=0.02
res@tmYLLabelDeltaF=-0.5

resv=True
resv@gsnDraw=False
resv@gsnFrame=False
resv@gsnAddCyclic=False
resv@gsnLeftString=""
resv@gsnRightString=""
resv@vcPositionMode            = "ArrowCenter"  
resv@vcGlyphStyle              = "Fillarrow"  
resv@vcFillArrowEdgeThicknessF = 2        
resv@vcFillArrowEdgeColor      = "white"   
resv@vcFillArrowFillColor      = "black"  
resv@vcFillArrowWidthF         = 0.2     
resv@vcFillArrowHeadXF         = 0.01       
resv@vcFillArrowHeadYF         = 0.001      
resv@vcFillArrowHeadInteriorXF = 0.001         
resv@vcMinDistanceF            = 0.01    
; resv@vcMinMagnitudeF           = 1.0    
resv@vcFillArrowMinFracWidthF =1.0 
resv@vcFillArrowHeadMinFracXF =1.0  
resv@vcFillArrowHeadMinFracYF =1.0 
resv@vcRefAnnoOn               = False 
resv@vcRefMagnitudeF           = 1.0  
resv@vcRefLengthF              = 0.005   

pres = True
pres@txString = ""
pres@gsnPanelLabelBar = False
;pres@gsnPanelFigureStrings = (/"a","b","c","d","e"/)
pres@gsnPanelFigureStringsFontHeightF=0.01
pres@amJust = "Topleft"
; pres@lbLabelFontHeightF = 0.015
; pres@lbLabelStride = 1

setfileoption("nc","Format","LargeFile")
setvalues NhlGetWorkspaceObjectId()
  "wsMaximumSize": 600000000
end setvalues

wks_type="png"
wks_type@wkWidth=10000
wks_type@wkHeight=10000
wks=gsn_open_wks(wks_type,fig_dir+fig_name)
;;--------------------------------------------------------------;;
base = new(11,graphic)
plot = new(11,graphic)
pi=3.14159265
file_1 = (/"lambda1-sgs-size3-2deg-1yr-2008.nc",\
          "lambda1-stationary-size3-2deg-1yr-2008.nc","lambda1-transient-size3-2deg-1yr-2008.nc",\
            "lambda1-Rynlds-size3-2deg-1yr-2008.nc","lambda1-nonRynlds-size3-2deg-1yr-2008.nc"/)
file_2 = (/"lambda2-sgs-size3-2deg-1yr-2008.nc",\
          "lambda2-stationary-size3-2deg-1yr-2008.nc","lambda2-transient-size3-2deg-1yr-2008.nc",\
            "lambda2-Rynlds-size3-2deg-1yr-2008.nc","lambda2-nonRynlds-size3-2deg-1yr-2008.nc"/)
file_3 = (/"alpha-PV-sgs-size3-2deg-1yr-2008.nc",\
          "alpha-PV-stationary-size3-2deg-1yr-2008.nc","alpha-PV-transient-size3-2deg-1yr-2008.nc",\
            "alpha-PV-Rynlds-size3-2deg-1yr-2008.nc","alpha-PV-nonRynlds-size3-2deg-1yr-2008.nc"/)
file_4 = (/"beta-PV-sgs-size3-2deg-1yr-2008.nc",\
          "beta-PV-stationary-size3-2deg-1yr-2008.nc","beta-PV-transient-size3-2deg-1yr-2008.nc",\
            "beta-PV-Rynlds-size3-2deg-1yr-2008.nc","beta-PV-nonRynlds-size3-2deg-1yr-2008.nc"/)
panel_name1 = (/"(a) lambda1-ttl-sfs","(b) lambda1-stt-sfs","(c) lambda1-trs-sfs",\
                "(d) lambda1-ttl-Rynlds","(e) lambda1-ttl-nonRynlds"/)
panel_name2 = (/"(g) lambda2-ttl-sfs","(h) lambda2-stt-sfs","(i) lambda2-trs-sfs",\
                "(j)lambda2-ttl-Rynlds","(k) lambda2-ttl-nonRynlds"/)

res1 = res
res1@cnFillPalette="ncl_default"
; res1@cnLevelSelectionMode="ExplicitLevels"
; res1@cnLevels       = (/-5000,-4500,-4000,-3500,-3000,-2500,-2000,-1500,-1000,-500,0,500,1000,1500,2000,2500,3000,3500,4000,4500,5000/)
; res1@cnFillColors       = (/10,20,30,40,50,60,70,80,90,105,120,    135,145,155,165,175,185,195,205,215,225,235/)
;;---------------------------------------------;;
values = fspan(-5000,5000,101)

fill = new(102,integer)
fill_wrk = fspan(15,125,51)
fill(0:50) = floattoint(fill_wrk)
fill_wrk = fspan(130,240,51)
fill(51:101) = floattoint(fill_wrk)
;print(fill)
;;---------------------------------------------;;
res1@cnLevelSelectionMode="ExplicitLevels"
res1@cnLevels       = values
res1@cnFillColors       = fill
res1@lbLabelStride = 10

do ivar=0,4
    f1=addfile(dir+file_1(ivar),"r")  
    var=f1->lambda1(0,2,:,0:2159)
    f2=addfile(dir+file_3(ivar),"r")  
    angle=f2->alpha(0,2,:,0:2159)

    vec1 = cos(angle/180.0*pi)
    vec2 = sin(angle/180.0*pi)
    copy_VarMeta(angle,vec1)
    copy_VarMeta(angle,vec2)

    res1@gsnLeftString = panel_name1(ivar)
    base(ivar)=gsn_csm_contour_map(wks,var(:,0:2159),res1)
    plot(ivar)=gsn_csm_vector(wks,vec1(:,0:2159),vec2(:,0:2159),resv)
    overlay(base(ivar),plot(ivar))

    delete([/var,angle,vec1,vec2/])

    f1=addfile(dir+file_2(ivar),"r")  
    var=f1->lambda2(0,2,:,0:2159)
    f2=addfile(dir+file_4(ivar),"r")  
    angle=f2->beta(0,2,:,0:2159)

    vec1 = cos(angle/180.0*pi)
    vec2 = sin(angle/180.0*pi)
    copy_VarMeta(angle,vec1)
    copy_VarMeta(angle,vec2)

    res1@gsnLeftString = panel_name2(ivar)
    base(ivar+6)=gsn_csm_contour_map(wks,var(:,0:2159),res1)
    plot(ivar+6)=gsn_csm_vector(wks,vec1(:,0:2159),vec2(:,0:2159),resv)
    overlay(base(ivar+6),plot(ivar+6))

    delete([/var,angle,vec1,vec2/])
end do


;;---------------------------------------------;;
res2 = res
res2@cnFillPalette="MPL_YlGnBu"
var_max=5000
var_min=500
spa=(var_max-var_min)/18
res2@cnLevelSelectionMode="ManualLevels"
res2@cnMaxLevelValF=var_max
res2@cnMinLevelValF=var_min
res2@cnLevelSpacingF=spa
res2@lbLabelStride = 1

f=addfile(dir+"topography/topography_SOSE.nc","r")
var=f->topo(:,0:2159)

res2@gsnLeftString="(f) SOSE topography"
base(5)=gsn_csm_contour_map(wks,var,res2)
delete([/f,var/])
;;---------------------------------------------;;

gsn_panel(wks,base,(/4,3/),pres)


end
