load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begin

dir = (/"../SOSE/K_tensor-2deg/eigen/",\
       "../SOSE/topography/",\
       "../SOSE/PV_grad/",\
       "../SOSE/"/)
pic_dir = "./"
vname_1 = (/"lambda1","lambda1","lambda1","lambda2","lambda2","lambda2"/)
vname_2 = (/"alpha","alpha","alpha","beta","beta","beta"/)

file_1 = (/"lambda1-sgs-size3-2deg-1yr-2008.nc",\
           "lambda1-stationary-size3-2deg-1yr-2008.nc",\ 
           "lambda1-transient-size3-2deg-1yr-2008.nc",\
           "lambda2-sgs-size3-2deg-1yr-2008.nc",\
           "lambda2-stationary-size3-2deg-1yr-2008.nc",\ 
           "lambda2-transient-size3-2deg-1yr-2008.nc"/)
file_2 = (/"alpha-PV-sgs-size3-2deg-1yr-2008.nc",\
           "alpha-PV-stationary-size3-2deg-1yr-2008.nc",\
           "alpha-PV-transient-size3-2deg-1yr-2008.nc",\
           "beta-PV-sgs-size3-2deg-1yr-2008.nc",\
           "beta-PV-stationary-size3-2deg-1yr-2008.nc",\
           "beta-PV-transient-size3-2deg-1yr-2008.nc"/)

file_5 = (/"topography-ppx-2deg_SOSE.nc",\
           "topography-ppy-2deg_SOSE.nc"/)
file_6 = (/"pqpx-2deg-1yr-2008.nc",\
           "pqpy-2deg-1yr-2008.nc"/)
file_7 = (/"us/us-Smean-2deg-1yr-2008.nc",\
           "vs/vs-Smean-2deg-1yr-2008.nc"/)
pic_name = "figureC9"
pi=3.14159265
eps=1e-20
num_bin=45
bin_int=90.0/num_bin
bin_start=0.0
wrk_bin=new((/320,2160/),double)
wrk_all=new((/320,2160/),double)
frac=new((/18,num_bin/),double) ;;45 bins
x = fspan(0,90,num_bin)
plot = new(3,graphic)
factor1=5.0  ;; here
factor2=2.0

ff=addfile(dir+"zz_topo/outcrop-counter-sose-2008.nc", "r")
daynum=ff->daynum(0,2,:,0:2159)
daynum = (daynum/73.0)*100.0

ff1=addfile(dir(1)+file_5(0),"r")  ;;topography-ppx
print(dir(1)+file_5(0))
topo_ppx=ff1->ppx_topo(:,0:2159)
topo_ppx = where(abs(daynum).lt.1.0, topo_ppx, topo_ppx@_FillValue)
ff2=addfile(dir(1)+file_5(1),"r")  ;;topography-ppy
topo_ppy=ff2->ppy_topo(:,0:2159)
topo_ppy = where(abs(daynum).lt.1.0, topo_ppy, topo_ppy@_FillValue)
;;in case topo-slope have a vast area of zero vector
topo_ppx=where(topo_ppx.eq.0 .and. topo_ppy.eq.0, topo_ppx@_FillValue, topo_ppx)
topo_ppy=where(topo_ppx.eq.0 .and. topo_ppy.eq.0, topo_ppy@_FillValue, topo_ppy)
;;========================================
;var_shape=dimsizes(topo_ppx)
;cosine=new((/320,2160/),double)  ;;; here
;;========================================

ff3=addfile(dir(2)+file_6(0),"r")  ;;pqpx
pqpx=ff3->pqpx(0,2,:,0:2159)
pqpx = where(abs(daynum).lt.1.0, pqpx, pqpx@_FillValue)
ff4=addfile(dir(2)+file_6(1),"r")  ;;pqpy
pqpy=ff4->pqpy(0,2,:,0:2159)
pqpy = where(abs(daynum).lt.1.0, pqpy, pqpy@_FillValue)

ff5=addfile(dir(3)+file_7(0),"r")  ;;ubar
ubar=ff5->ubar(0,2,:,0:2159)
ubar = where(abs(daynum).lt.1.0, ubar, ubar@_FillValue)
lat=ff5->lat
ff6=addfile(dir(3)+file_7(1),"r")  ;;vbar
vbar=ff6->vbar(0,2,:,0:2159)
vbar = where(abs(daynum).lt.1.0, vbar, vbar@_FillValue)


do ifile=0,2

f1=addfile(dir(0)+file_1(ifile),"r")  ;;lambda1-ttl
f4=addfile(dir(0)+file_1(ifile+3),"r")  ;;lambda2-ttl
lambda1=f1->lambda1(0,2,:,0:2159)
lambda2=f4->lambda2(0,2,:,0:2159)
lambda1 = where(abs(daynum).lt.1.0, lambda1, lambda1@_FillValue)
lambda2 = where(abs(daynum).lt.1.0, lambda2, lambda2@_FillValue)
printVarSummary(lambda2)

fin1=addfile(dir(0)+file_2(ifile),"r")  ;;alpha-ttl
fin4=addfile(dir(0)+file_2(ifile+3),"r")  ;;beta-ttl
alpha=fin1->alpha(0,2,:,0:2159)
beta=fin4->beta(0,2,:,0:2159)
alpha = where(abs(daynum).lt.1.0, alpha, alpha@_FillValue)
beta = where(abs(daynum).lt.1.0, beta, beta@_FillValue)

;;===============================
;; ttl
;;===============================
alpha_strong=where(abs(lambda1/lambda2).gt.factor1,alpha,alpha@_FillValue)
beta_strong=where(abs(lambda1/lambda2).lt.1.0/factor1,beta,beta@_FillValue)
alpha_strong=where(ismissing(alpha_strong),0.0,alpha_strong)
beta_strong=where(ismissing(beta_strong),0.0,beta_strong)
angle_strong=alpha_strong+beta_strong
angle_strong=where(angle_strong.eq.0.0,angle_strong@_FillValue,angle_strong)
vec_1_strong = cos(angle_strong/180.0*pi)
vec_2_strong = sin(angle_strong/180.0*pi)
copy_VarMeta(angle_strong,vec_1_strong)
copy_VarMeta(angle_strong,vec_2_strong)
;;--------------------------------------------------------
alpha_weak=where((abs(lambda1/lambda2).lt.factor2).and.(abs(lambda1/lambda2).gt.1.0),\
                alpha,alpha@_FillValue)
beta_weak=where((abs(lambda1/lambda2).gt.1.0/factor2).and.(abs(lambda1/lambda2).lt.1.0),\
               beta,beta@_FillValue)
alpha_weak=where(ismissing(alpha_weak),0.0,alpha_weak)
beta_weak=where(ismissing(beta_weak),0.0,beta_weak)
angle_weak=alpha_weak+beta_weak
angle_weak=where(angle_weak.eq.0.0,angle_weak@_FillValue,angle_weak)
vec_1_weak = cos(angle_weak/180.0*pi)
vec_2_weak = sin(angle_weak/180.0*pi)
copy_VarMeta(angle_weak,vec_1_weak)
copy_VarMeta(angle_weak,vec_2_weak)
;;--------------------------------------------------------


;;PV-grad
cosine = (abs(vec_1_strong*pqpx + vec_2_strong*pqpy))/   \
        (sqrt(vec_1_strong^2.0+vec_2_strong^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
var = acos(cosine)*180.0/pi
;;;===========================================================
wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
printVarSummary((wrk_all))
do jj=0,319
      wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
end do
do nbin=0,num_bin-1
    wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

    do jj=0,319
        wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    frac(ifile,nbin)=sum(wrk_bin)/sum(wrk_all) ;;pv-ttl-strong 0,pv-stt-strong 1,pv-trs-strong 2
end do


cosine = (abs(vec_1_weak*pqpx + vec_2_weak*pqpy))/   \
        (sqrt(vec_1_weak^2.0+vec_2_weak^2.0)*sqrt(pqpx^2.0+pqpy^2.0)+eps)
var = acos(cosine)*180.0/pi
;;;===========================================================
wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
printVarSummary((wrk_all))
do jj=0,319
      wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
end do
do nbin=0,num_bin-1
    wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

    do jj=0,319
        wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    frac(ifile+3,nbin)=sum(wrk_bin)/sum(wrk_all) ;;pv-ttl-weak 3,pv-stt-weak 4,pv-trs-weak 5
end do
;;;===========================================================

;;U vector
cosine = (abs(vec_1_strong*ubar + vec_2_strong*vbar))/   \
        (sqrt(vec_1_strong^2.0+vec_2_strong^2.0)*sqrt(ubar^2.0+vbar^2.0)+eps)
var = acos(cosine)*180.0/pi
;;;===========================================================
wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
printVarSummary((wrk_all))
do jj=0,319
      wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
end do
do nbin=0,num_bin-1
    wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

    do jj=0,319
        wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    frac(ifile+6,nbin)=sum(wrk_bin)/sum(wrk_all) ;;u-ttl-strong 6,u-stt-strong 7,u-trs-strong 8
end do
;;;===========================================================
cosine = (abs(vec_1_weak*ubar + vec_2_weak*vbar))/   \
        (sqrt(vec_1_weak^2.0+vec_2_weak^2.0)*sqrt(ubar^2.0+vbar^2.0)+eps)
var = acos(cosine)*180.0/pi
;;;===========================================================
wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
printVarSummary((wrk_all))
do jj=0,319
      wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
end do
do nbin=0,num_bin-1
    wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

    do jj=0,319
        wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    frac(ifile+9,nbin)=sum(wrk_bin)/sum(wrk_all) ;;u-ttl-weak 9,u-stt-weak 10,u-trs-weak 11
end do
;;;===========================================================

;;topo-slope
cosine = (abs(vec_1_strong*topo_ppx + vec_2_strong*topo_ppy))/   \
        (sqrt(vec_1_strong^2.0+vec_2_strong^2.0)*sqrt(topo_ppx^2.0+topo_ppy^2.0)+eps)
var = acos(cosine)*180.0/pi
;;;===========================================================
wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
printVarSummary((wrk_all))
do jj=0,319
      wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
end do
do nbin=0,num_bin-1
    wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

    do jj=0,319
        wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    frac(ifile+12,nbin)=sum(wrk_bin)/sum(wrk_all) ;;topo-ttl-strong 12,topo-stt-strong 13,topo-trs-strong 14
end do
;;;===========================================================
cosine = (abs(vec_1_weak*topo_ppx + vec_2_weak*topo_ppy))/   \
        (sqrt(vec_1_weak^2.0+vec_2_weak^2.0)*sqrt(topo_ppx^2.0+topo_ppy^2.0)+eps)
var = acos(cosine)*180.0/pi
;;;===========================================================
wrk_all = where((var.gt.0.0 .and. var.lt.90.0),1,0)
printVarSummary((wrk_all))
do jj=0,319
      wrk_all(jj,:) = wrk_all(jj,:)*cos(lat(jj)/180.0*pi)
end do
do nbin=0,num_bin-1
    wrk_bin = where((var.gt.(bin_start+nbin*bin_int) .and. var.lt.(bin_start+(nbin+1)*bin_int)),1,0)

    do jj=0,319
        wrk_bin(jj,:) = wrk_bin(jj,:)*cos(lat(jj)/180.0*pi)
    end do

    frac(ifile+15,nbin)=sum(wrk_bin)/sum(wrk_all) ;;topo-ttl-weak 15,topo-stt-weak 16,topo-trs-weak 17
end do
;;;===========================================================

end do

;wks = gsn_open_wks("pdf", pic_dir+pic_name)
wks = gsn_open_wks("png", pic_dir+pic_name)
;gsn_define_colormap(wks, "MPL_Greys")

res = True
res@gsnDraw               = False
res@gsnFrame              = False
res@vpWidthF              = 0.4
res@vpHeightF             = 0.4

res@trXMinF               = 0.0
res@trXMaxF               = 90.0
res@trYMinF               = 0.0
res@trYMaxF               = 10.0

; res@gsnXYBarChart         = True
; res@gsnXYBarChartBarWidth = 1.0           ; change bar widths
res@tmXBLabelFontHeightF  = 0.018
res@tmYLLabelFontHeightF  = 0.018
; res@gsnRightString        = ""
; res@gsnXYBarChartColors = "purple"
; res@gsnXYBarChartOutlineThicknessF = 0.001

res@xyLineThicknesses=(/3,3,3,2,2,2/)
res@xyLineColors=(/"black","blue","red","black","blue","red"/)
res@xyDashPatterns=(/0,0,0,2,2,2/)

res@pmLegendWidthF=0.09
res@pmLegendHeightF=0.15
res@pmLegendOrthogonalPosF=-1.05
res@pmLegendParallelPosF=0.75


do ivar=0,2
  if(ivar.eq.1)then
    res@pmLegendDisplayMode="Always"
    res@xyExplicitLegendLabels=(/"ttl-anisotropy","stt-anisotropy","trs-anisotropy",\
                                "ttl-isotropy","stt-isotropy","trs-isotropy"/)
    res@lgLabelFontHeightF=0.016
  end if

  if(ivar.eq.2)then
    res@pmLegendDisplayMode="NoCreate"
  end if
    ;pp = sqrt(frac(ivar,:)*100)
    pp = frac(ivar*6:ivar*6+5,:)*100
    plot(ivar) = gsn_csm_xy(wks,x,pp,res)
end do


pres = True
pres@txString = ""
pres@txFontHeightF = 0.015
;pres@gsnPanelLabelBar = True
pres@gsnPanelFigureStrings = (/"(a) with PV_gradient", \
                              "(b) with U_vector",\
                              "(c) with topography_slope"/)
pres@gsnPanelFigureStringsFontHeightF = 0.012
pres@amJust = "Topleft"
gsn_panel(wks,plot,(/1,3/),pres)

; print(frac(1,10:12))
; print(frac(2,10:12))

end
