load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begin

;;==============================================================
res = True
res@gsnDraw=False
res@gsnFrame=False
res@gsnAddCyclic=False
res@gsnCenterString=""
res@gsnLeftStringFontHeightF = 0.012
res@gsnRightString=""
res@cnFillOn=True
res@cnLinesOn=False
res@cnFillMode = "RasterFill"
res@cnRasterSmoothingOn = True
res@lbLabelBarOn = False
res@mpCenterLonF=180
res@mpMaxLonF=359
res@mpMinLonF=1
res@mpMaxLatF=-25
res@mpMinLatF=-75
; res@cnLevelSelectionMode="ExplicitLevels"
; res@cnLevels       = (/-30000,-10000,-3000,-1000,-300,-100,-30,-10,-3,0,3,10,30,100,300,1000,3000,10000,30000/)
; res@cnFillColors       = (/4,7,10,20,35,50,65,80,100,120,    136,155,175,195,210,225,240,245,248,251/)
res@cnLevelSelectionMode="ManualLevels"
res@cnMaxLevelValF=2
res@cnMinLevelValF=0
res@cnLevelSpacingF=0.2
res@mpMonoFillColor = True
res@mpFillColor = "gray79"

pres = True
pres@gsnPanelLabelBar = True
;pres@gsnPanelFigureStrings = (/"a","b","c","d","e"/)
pres@gsnPanelFigureStringsFontHeightF=0.01
pres@amJust = "Topleft"
pres@lbLabelFontHeightF = 0.015
pres@lbLabelStride = 1
pres@txString = ""

wks_type="png"
wks_type@wkWidth=5000
wks_type@wkHeight=5000
;;==============================================================

setfileoption("nc","Format","LargeFile")
setvalues NhlGetWorkspaceObjectId()
  "wsMaximumSize": 600000000
end setvalues

dir = "../SOSE/flux/"
fig_dir = "./"
label = (/"-size1","-size2","-size3","-size4","-size6","-size9"/)
panel_name = (/"(a) boxsize = 3*3, 9 samples","(b) boxsize = 5*5, 25 samples",\
              "(c) boxsize = 7*7, 49 samples","(d) boxsize = 9*9, 81 samples",\
              "(e) boxsize = 13*13, 169 samples","(f) boxsize = 19*19, 361 samples"/)

;; ======== difference between orig and reconstruct flux_y ========
base = new(6,graphic)
wks=gsn_open_wks(wks_type,fig_dir+"figureS2")
gsn_define_colormap(wks,"rainbow")

f=addfile(dir+"F-vq-sgs-2deg-1yr-2008.nc","r")
flux=f->flux(0,2,:,0:2159)
flux=flux*1e+16

do ilabel=0,5
  f=addfile(dir+"flux_check/Fre-vq-sgs"+label(ilabel)+"-2deg-1yr-2008.nc","r")
  var=f->flux(0,2,:,0:2159)
  var=var*1e+16
  var = abs((var - flux)/flux)
  
  res@gsnLeftString=panel_name(ilabel)
  base(ilabel)=gsn_csm_contour_map(wks,var(:,0:2159),res)
end do

gsn_panel(wks,base,(/6,1/),pres)


; draw(base_f)
; frame(wks1)


end
