load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begin

;;---------------------------------------------;;
res = True
res@gsnDraw=False
res@gsnFrame=False
res@gsnAddCyclic=False
res@gsnCenterString=""
res@gsnLeftStringFontHeightF = 0.012
res@gsnRightString=""
res@mpCenterLonF=180
res@mpMaxLonF=359
res@mpMinLonF=1
res@mpMaxLatF=-25
res@mpMinLatF=-75
res@mpMonoFillColor = True
res@mpFillColor = "gray79"

res@cnFillOn=True
res@cnLinesOn=False
res@cnFillMode = "RasterFill"
res@lbLabelBarOn = True
res@lbLabelFontHeightF = 0.01
res@lbLabelStride = 1
res@pmLabelBarOrthogonalPosF=0.11
res@tmXBLabelFontHeightF=0.0075
res@tmXBLabelDeltaF=-0.5
res@tmYLLabelFontHeightF=0.0075
res@tmYLLabelDeltaF=-0.5
;res@cnLineThicknessF=0.1
res@lbBoxLinesOn=False

res1=res
res2=res

res@lbLabelStride = 25

pres = True
pres@txString = ""
pres@gsnPanelLabelBar = False
;pres@gsnPanelFigureStrings = (/"a","b","c","d","e"/)
;pres@gsnPanelFigureStringsFontHeightF=0.01
;pres@amJust = "Topleft"
;pres@lbLabelFontHeightF = 0.015
;pres@lbLabelStride = 1
;;---------------------------------------------;;

values = new(201,double)
aa = fspan(0,4,101)
values(101:200)=10^aa(1:100)
bb = fspan(4,0,101)
values(0:99)=10^bb(0:99)
values(100)=0.0
values(0:99)=-values(0:99)
;print(values)

fill = new(202,integer)
fill_wrk = fspan(25,125,101)
fill(0:100) = floattoint(fill_wrk)
fill_wrk = fspan(130,230,101)
fill(101:201) = floattoint(fill_wrk)
;print(fill)
;;---------------------------------------------;;


dir = "../SOSE/"
base = new(4,graphic)
wks_type="png"
wks_type@wkWidth=10000
wks_type@wkHeight=10000
wks=gsn_open_wks(wks_type,"./figureS3")

;;---------------------------------------------;;
res@cnFillPalette="ncl_default"
res@cnLevelSelectionMode="ExplicitLevels"
res@cnLevels       = values
res@cnFillColors       = fill
; res@cnLevelSelectionMode="ExplicitLevels"
; res@cnLevels       = (/-100000,-10000,-1000,-100,-10,-1,0,1,10,100,1000,10000,100000/)
; res@cnFillColors       = (/10,20,35,50,65,80,110,    140,153,170,190,205,217,230/)
; var_max=1000
; var_min=-1000
; spa=(var_max-var_min)/200
; res@cnLevelSelectionMode="ManualLevels"
; res@cnMaxLevelValF=var_max
; res@cnMinLevelValF=var_min
; res@cnLevelSpacingF=spa
;;---------------------------------------------;;

f1=addfile(dir+"flux/F-vq-sgs-2deg-1yr-2008.nc","r")
var1=f1->flux(0,2,:,0:2159)
var1=var1*1e12

f2=addfile(dir+"flux/flux_check/Fre-vq-sgs-size3-2deg-1yr-2008.nc","r")
var2=f2->flux(0,2,:,0:2159)
var2=var2*1e12

diff = var1 - var2
copy_VarMeta(var1, diff)

res@gsnLeftString="(a) flux-sfs-ttl"
base(0)=gsn_csm_contour_map(wks,var1,res)

res@gsnLeftString="(b) flux-reconstruct"
base(1)=gsn_csm_contour_map(wks,var2,res)

res@gsnLeftString="(c) difference"
base(2)=gsn_csm_contour_map(wks,diff,res)

delete([/f1,f2,var1,var2,diff/])

;;---------------------------------------------;;
res2@cnFillPalette="MPL_YlGnBu"
var_max=5000
var_min=500
spa=(var_max-var_min)/18
res2@cnLevelSelectionMode="ManualLevels"
res2@cnMaxLevelValF=var_max
res2@cnMinLevelValF=var_min
res2@cnLevelSpacingF=spa

f=addfile("../SOSE/topography/topography_SOSE.nc","r")
var=f->topo(:,0:2159)

res2@gsnLeftString="(d) SOSE topography"
base(3)=gsn_csm_contour_map(wks,var,res2)

delete([/f,var/])
;;---------------------------------------------;;

gsn_panel(wks,base,(/4,1/),pres)

; draw(base(0))
; frame(wks)

end
