load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"

begin



;;==============================================================
res = True
res@gsnDraw=False
res@gsnFrame=False
res@gsnAddCyclic=False
res@gsnCenterString=""
res@gsnLeftStringFontHeightF = 0.012
res@gsnRightString=""
res@cnFillOn=True
res@cnLinesOn=False
res@cnFillMode = "RasterFill"
res@cnRasterSmoothingOn = True
res@lbLabelBarOn = False
res@mpCenterLonF=180
res@mpMaxLonF=359
res@mpMinLonF=1
res@mpMaxLatF=-25
res@mpMinLatF=-75
res@mpMonoFillColor = True
res@mpFillColor = "gray79"

pres = True
pres@gsnPanelLabelBar = True
;pres@gsnPanelFigureStrings = (/"a","b","c","d","e"/)
pres@gsnPanelFigureStringsFontHeightF=0.01
pres@amJust = "Topleft"
pres@lbLabelFontHeightF = 0.015
pres@lbLabelStride = 25
pres@txString = "meridional salinity flux"
pres@txFontHeightF = 0.02
pres@lbBoxLinesOn=False
pres@pmLabelBarWidthF = 0.8
pres@pmLegendHeightF = 0.6
pres@pmLabelBarParallelPosF = -0.026

wks_type="png"
wks_type@wkWidth=5000
wks_type@wkHeight=5000
;;==============================================================
values = new(201,double)
aa = fspan(0,4,101)
values(101:200)=10^aa(1:100)
bb = fspan(4,0,101)
values(0:99)=10^bb(0:99)
values(100)=0.0
values(0:99)=-values(0:99)
;print(values)

fill = new(202,integer)
fill_wrk = fspan(25,125,101)
fill(0:100) = floattoint(fill_wrk)
fill_wrk = fspan(130,230,101)
fill(101:201) = floattoint(fill_wrk)
;print(fill)
;;---------------------------------------------;;
res@cnFillPalette="ncl_default"
res@cnLevelSelectionMode="ExplicitLevels"
res@cnLevels       = values
res@cnFillColors       = fill

setfileoption("nc","Format","LargeFile")
setvalues NhlGetWorkspaceObjectId()
  "wsMaximumSize": 600000000
end setvalues

dir1 = "../SOSE/K_tensor-2deg/"
dir2 = "../SOSE/check_tracer/flux/"
dir3 = "../SOSE/ss_grad/"
fname = (/"Kyx-sgs-size3","Kyy-sgs-size3",\
         "Kyx-Rynlds-size3","Kyy-Rynlds-size3",\
         "Kyx-transient-size3","Kyy-transient-size3"/)
fname2 = (/"F-vs-sgs-2deg-1yr-2008.nc",\
          "F-vs-Rynlds-2deg-1yr-2008.nc",\
          "F-vs-transient-2deg-1yr-2008.nc"/)
suffix = "-2deg-1yr-2008.nc"
panel_name = (/"(a) sfs-ttl","(b) reconstruct, sfs-ttl",\
              "(c) Rynlds-ttl","(d) reconstruct, Rynlds-ttl",\
              "(e) sfs-trs","(f) reconstruct, sfs-trs"/)
fig_dir = "./"

base = new(6,graphic)
wks=gsn_open_wks(wks_type,fig_dir+"figureS5")

f=addfile(dir3+"pspx-2deg-1yr-2008.nc","r") ;;pspx
pspx=f->pspx(0,2,:,0:2159)

f=addfile(dir3+"pspy-2deg-1yr-2008.nc","r") ;;pspy
pspy=f->pspy(0,2,:,0:2159)

do ii=0,2
    ;;-------------------------------------------------------;;
    f1=addfile(dir1+fname(ii*2)+suffix,"r") ;;Kyx
    Kyx=f1->Kyx(0,2,:,0:2159)

    f2=addfile(dir1+fname(ii*2+1)+suffix,"r") ;;Kyy
    Kyy=f2->Kyy(0,2,:,0:2159)
    ;;-------------------------------------------------------;;

    fy_ss_re = -(Kyx*pspx + Kyy*pspy)*1e+5
    copy_VarMeta(Kyy, fy_ss_re)

    f=addfile(dir2+fname2(ii),"r")
    fy_ss_orig = f->flux(0,2,:,0:2159)
    fy_ss_orig = fy_ss_orig*1e+5
    ;;-------------------------------------------------------;;

    res@gsnLeftString=panel_name(ii*2)
    base(ii*2)=gsn_csm_contour_map(wks,fy_ss_orig(:,0:2159),res)

    res@gsnLeftString=panel_name(ii*2+1)
    base(ii*2+1)=gsn_csm_contour_map(wks,fy_ss_re(:,0:2159),res)

    delete([/Kyx,Kyy,fy_ss_re,fy_ss_orig/])

end do

gsn_panel(wks,base,(/6,1/),pres)


end
